unit BeRoVectorFont; // Copyright (C) 2008, Benjamin 'BeRo' Rosseaux - bero.0ok.de - Give credits!
{$undef caninline}
{$ifdef fpc}
 {$mode delphi}
 {$define caninline}
{$else}
 {$ifdef ver180}
   {$define caninline}
  {$endif}
  {$ifdef conditionalexpressions}
   {$if compilerversion>=18}
    {$define caninline}
   {$ifend}
  {$endif}
{$endif}

interface

uses BeRoStream,BeRoUtils;

const PID_AppleUnicode=0;
      PID_Macintosh=1;
      PID_ISO=2;
      PID_Microsoft=3;

      SID_MAC_Roman=0;
      SID_MAC_Japanese=1;
      SID_MAC_Chinese=2;
      SID_MAC_Korean=3;
      SID_MAC_Arabic=4;
      SID_MAC_Hebrew=5;
      SID_MAC_Greek=6;
      SID_MAC_Russian=7;
      SID_MAC_RSymbol=8;
      SID_MAC_Devanagari=9;
      SID_MAC_Gurmukhi=10;
      SID_MAC_Gujarati=11;
      SID_MAC_Oriya=12;
      SID_MAC_Bengali=13;
      SID_MAC_Tamil=14;
      SID_MAC_Telugu=15;
      SID_MAC_Kannada=16;
      SID_MAC_Malayalam=17;
      SID_MAC_Sinhalese=18;
      SID_MAC_Burmese=19;
      SID_MAC_Khmer=20;
      SID_MAC_Thai=21;
      SID_MAC_Laotian=22;
      SID_MAC_Georgian=23;
      SID_MAC_Armenian=24;
      SID_MAC_Maldivian=25;
      SID_MAC_Tibetian=26;
      SID_MAC_Mongolian=27;
      SID_MAC_Geez=28;
      SID_MAC_Slavic=29;
      SID_MAC_Vietnamese=30;
      SID_MAC_Sindhi=31;
      SID_MAC_Uninterp=32;

      SID_MS_Undefined=0;
      SID_MS_UNICODE=1;

      SID_ISO_ASCII=0;
      SID_ISO_10646=1;
      SID_ISO_8859_1=2;

      LID_MS_Arabic=$0401;
      LID_MS_Bulgarian=$0402;
      LID_MS_Catalan=$0403;
      LID_MS_TraditionalChinese=$0404;
      LID_MS_SimplifiedChinese=$0804;
      LID_MS_Czech=$0405;
      LID_MS_Danish=$0406;
      LID_MS_German=$0407;
      LID_MS_SwissGerman=$0807;
      LID_MS_Greek=$0408;
      LID_MS_USEnglish=$0409;
      LID_MS_UKEnglish=$0809;
      LID_MS_CastilianSpanish=$040a;
      LID_MS_MexicanSpanish=$080a;
      LID_MS_ModernSpanish=$0c0a;
      LID_MS_Finnish=$040b;
      LID_MS_French=$040c;
      LID_MS_BelgianFrench=$080c;
      LID_MS_CanadianFrench=$0c0c;
      LID_MS_SwissFrench=$100c;
      LID_MS_Hebrew=$040d;
      LID_MS_Hungarian=$040e;
      LID_MS_Icelandic=$040f;
      LID_MS_Italian=$0410;
      LID_MS_SwissItalian=$0810;
      LID_MS_Japanese=$0411;
      LID_MS_Korean=$0412;
      LID_MS_Dutch=$0413;
      LID_MS_BelgianDutch=$0813;
      LID_MS_NorwegianBokmal=$0414;
      LID_MS_NorwegianNynorsk=$0814;
      LID_MS_Polish=$0415;
      LID_MS_BrazilianPortuguese=$0416;
      LID_MS_Portuguese=$0816;
      LID_MS_RhaetoRomanic=$0417;
      LID_MS_Romanian=$0418;
      LID_MS_Russian=$0419;
      LID_MS_CroatoSerbian=$041a;
      LID_MS_SerboCroatian=$081a;
      LID_MS_Slovakian=$041b;
      LID_MS_Albanian=$041c;
      LID_MS_Swedish=$041d;
      LID_MS_Thai=$041e;
      LID_MS_Turkish=$041f;
      LID_MS_Urdu=$0420;
      LID_MS_Bahasa=$0421;

      LID_MAC_English=0;
      LID_MAC_French=1;
      LID_MAC_German=2;
      LID_MAC_Italian=3;
      LID_MAC_Dutch=4;
      LID_MAC_Swedish=5;
      LID_MAC_Spanish=6;
      LID_MAC_Danish=7;
      LID_MAC_Portuguese=8;
      LID_MAC_Norwegian=9;
      LID_MAC_Hebrew=10;
      LID_MAC_Japanese=11;
      LID_MAC_Arabic=12;
      LID_MAC_Finnish=13;
      LID_MAC_Greek=14;
      LID_MAC_Icelandic=15;
      LID_MAC_Maltese=16;
      LID_MAC_Turkish=17;
      LID_MAC_Yugoslavian=18;
      LID_MAC_Chinese=19;
      LID_MAC_Urdu=20;
      LID_MAC_Hindi=21;
      LID_MAC_Thai=22;

      NID_Copyright=0;
      NID_Family=1;
      NID_Subfamily=2;
      NID_UniqueID=3;
      NID_FullName=4;
      NID_Version=5;
      NID_PostscriptName=6;
      NID_Trademark=7;

      CMAP_FORMAT0=0;
      CMAP_FORMAT2=2;
      CMAP_FORMAT4=4;
      CMAP_FORMAT6=6;

      OFFSET_TABLE_SIZE=12;

      MACINTOSH=1;
      MICROSOFT=2;

      TT_NO_POINT=0;
      TT_OFF_CURVE=1;
      TT_ON_CURVE=2;

      TT_ERR_NoError=0;
      TT_ERR_InvalidFile=1;
      TT_ERR_CorruptFile=2;
      TT_ERR_OutOfMemory=2;
      TT_ERR_TableNotFound=3;
      TT_ERR_NoCharacterMapFound=4;
      TT_ERR_UnknownCharacterMapFormat=5;
      TT_ERR_CharactermapNotPresent=6;
      TT_ERR_UnableToOpenFile=7;
      TT_ERR_UnknownKerningFormat=8;

type TBeRoVectorFontPoint=record
      x,y:double;
     end;

     TBeRoVectorFontStyle=(bvfsTHIN,bvfsBOLD,bvfsITALIC);
     TBeRoVectorFontStyles=set of TBeRoVectorFontStyle;
                                          
     TBeRoVectorFontCharStylePolygonCommandType=(bvfcspctMOVETO,bvfcspctLINETO,bvfcspctCURVETO);

     TBeRoVectorFontCharStylePolygonCommandPoints=array[0..1] of TBeRoVectorFontPoint;

     TBeRoVectorFontCharStylePolygonCommand=record
      CommandType:TBeRoVectorFontCharStylePolygonCommandType;
      Points:TBeRoVectorFontCharStylePolygonCommandPoints;
     end;
     
     TBeRoVectorFontCharStylePolygonCommands=array of TBeRoVectorFontCharStylePolygonCommand;

     TBeRoVectorFontCharStylePolygon=record
      Commands:TBeRoVectorFontCharStylePolygonCommands;
     end;

     TBeRoVectorFontCharStyle=record
      AdvanceWidth,AdvanceHeight,LeftSideBearing,RightSideBearing,TopSideBearing,BottomSideBearing,XMin,YMin,XMax,YMax:integer;
      Polygon:TBeRoVectorFontCharStylePolygon;
     end;

     TBeRoVectorFontGlyph=record
      AdvanceWidth,AdvanceHeight,LeftSideBearing,RightSideBearing,TopSideBearing,BottomSideBearing,XMin,YMin,XMax,YMax:integer;
      Styles:array[0..5] of TBeRoVectorFontCharStyle;
     end;
     TBeRoVectorFontGlyphs=array of TBeRoVectorFontGlyph;

     TBeRoVectorFontKerningPair=record
      Left,Right,Value:integer;
     end;

     TBeRoVectorFontKerningPairs=array of TBeRoVectorFontKerningPair;

     TBeRoVectorFontKerningTable=record
      Horizontal:boolean;
      ValueOverride:boolean;
      BinarySearch:boolean;
      KerningPairs:TBeRoVectorFontKerningPairs;
     end;

     TBeRoVectorFontKerningTables=array of TBeRoVectorFontKerningTable;

     TBeRoVectorFontCharacterMap=array[widechar] of integer;

     TBeRoVectorFontCommandType=(bvfctNONE,bvfctMOVETO,bvfctLINETO,bvfctQUADRATICCURVETO,bvfctCLOSE);

     TBeRoVectorFontCommand=record
      case Command:TBeRoVectorFontCommandType of
       bvfctMOVETO,bvfctLINETO:(x,y:double);
       bvfctQUADRATICCURVETO:(qcx,qcy,qax,qay:double);
     end;

     TBeRoVectorFontCommands=array of TBeRoVectorFontCommand;

     TBeRoVectorFont=class
      private
       Glyphs:TBeRoVectorFontGlyphs;
       KerningTables:TBeRoVectorFontKerningTables;
       CharacterMap:TBeRoVectorFontCharacterMap;
       AdvanceWidthMax,AdvanceHeightMax,UnitsPerEm,XMin,YMin,XMax,YMax:integer;
       function Kerning(Left,Right:integer;Horizontal:boolean):integer;
      public
       Name:widestring;
       Styles:TBeRoVectorFontStyles;
       Size:double;
       LetterSpacing:double;
       constructor Create;
       destructor Destroy; override;
       procedure Clear;
       function LoadTrueType(var Data;Size:integer;PlatformID:integer=PID_Microsoft;SpecificID:integer=SID_MS_UNICODE;LanguageID:integer=LID_MS_USEnglish):boolean; overload;
       function LoadTrueType(FileName:string;PlatformID:integer=PID_Microsoft;SpecificID:integer=SID_MS_UNICODE;LanguageID:integer=LID_MS_USEnglish):boolean; overload;
       function TextWidth(Text:widestring):double;
       function TextHeight(Text:widestring):double;
       procedure GetCommands(var Commands:TBeRoVectorFontCommands;x,y:double;Text:widestring);
     end;

implementation

const deg2rad=pi/180;
      rad2deg=180/pi;

type pbytearray=^tbytearray;
     tbytearray=array[0..65535] of byte;

     pbyte=^byte;
     pshortint=^shortint;
     pword=^word;
     psmallint=^smallint;
     plongword=^longword;
     plongint=^longint;
     pdouble=^double;

     TBeRoVectorFontMatrix=array[0..5] of double;

     TBeRoVectorFontTrueTypeKerningPair=packed record
      Left:word;
      Right:word;
      Value:smallint;
     end;
     TBeRoVectorFontTrueTypeKerningPairs=array of TBeRoVectorFontTrueTypeKerningPair;

     TBeRoVectorFontTrueTypeKerningTable=record
      Horizontal:boolean;
      ValueOverride:boolean;
      BinarySearch:boolean;
      KerningPairs:TBeRoVectorFontTrueTypeKerningPairs;
     end;
     TBeRoVectorFontTrueTypeKerningTables=array of TBeRoVectorFontTrueTypeKerningTable;

     TBeRoVectorFontTrueTypePoint=packed record
      X:integer;
      Y:integer;
      OnCurve:boolean;
     end;
     TBeRoVectorFontTrueTypePoints=array of TBeRoVectorFontTrueTypePoint;

     TBeRoVectorFontTrueTypeContour=record
      Points:TBeRoVectorFontTrueTypePoints;
     end;
     TBeRoVectorFontTrueTypeContours=array of TBeRoVectorFontTrueTypeContour;

     TBeRoVectorFontTrueTypeCompositeSubGlyph=record
      Glyph,Flags:word;
      x,y,xx,yx,xy,yy:integer;
     end;

     TBeRoVectorFontTrueTypeCompositeSubGlyphs=array of TBeRoVectorFontTrueTypeCompositeSubGlyph;

     PBeRoVectorCanvasTrueTypeGlyph=^TBeRoVectorFontTrueTypeGlyph;
     TBeRoVectorFontTrueTypeGlyph=record
      Contours:TBeRoVectorFontTrueTypeContours;
      Points:TBeRoVectorFontTrueTypePoints;
      CompositeSubGlyphs:TBeRoVectorFontTrueTypeCompositeSubGlyphs;
      XMin:smallint;
      YMin:smallint;
      XMax:smallint;
      YMax:smallint;
      AdvanceWidth:word;
      AdvanceHeight:word;
      LeftSideBearing:smallint;
      RightSideBearing:smallint;
      TopSideBearing:smallint;
      BottomSideBearing:smallint;
     end;
     TBeRoVectorFontTrueTypeGlyphs=array of TBeRoVectorFontTrueTypeGlyph;

     TBeRoVectorFontTrueTypeBytes=array of byte;

     TBeRoVectorFontTrueTypeLongword=array of longword;

     TBeRoVectorFontTrueType=class
      private
       FontData:TBeRoVectorFontTrueTypeBytes;
       Glyphs:TBeRoVectorFontTrueTypeGlyphs;
       CMap:TBeRoVectorFontTrueTypeBytes;
       GlyphOffsetArray:TBeRoVectorFontTrueTypeLongword;
       KerningTables:TBeRoVectorFontTrueTypeKerningTables;

       FontDataSize:integer;

       numberOfHMetrics:word;
       numberOfVMetrics:word;
       numTables:word;
       cmapFormat:word;

       LastError:word;
       indexToLocFormat:smallint;
       strcopyright:widestring;
       strfamily:widestring;
       strsubfamily:widestring;
       strfullName:widestring;
       struniqueid:widestring;
       strversion:widestring;
       strpostscript:widestring;
       strtrademark:widestring;
       xMax:smallint;
       xMin:smallint;
       yMax:smallint;
       yMin:smallint;
       unitsPerEm:word;
       ascender:word;
       descender:word;
       lineGap:word;
       AdvanceWidthMax:word;
       AdvanceHeightMax:word;
       platformID:word;
       specificID:word;
       languageID:word;
       function ReadFontData(DataPointer:pointer;DataSize:integer):integer;
       function GetTableDirEntry(Tag:longword;var CheckSum,Offset,Size:longword):integer;
       function ProcessFontHeaderTable:integer;
       function ProcessMaximumProfileTable:integer;
       function ProcessNamingTable:integer;
       function ProcessIndexToLocationTable:integer;
       function ProcessGlyphDataTable:integer;
       function ProcessHorizontalHeaderTable:integer;
       function ProcessHorizontalMetricsTable:integer;
       function ProcessVerticalHeaderTable:integer;
       function ProcessVerticalMetricsTable:integer;
       function ProcessKerningTable:integer;
       function ProcessCharacterMappingTable:integer;
       function GetGlyphIndex(CharCode:word):word;
      public
       constructor Create(DataPointer:pointer;DataSize:integer;pid,sid,lid:word);
       destructor Destroy; override;
       function numGlyphs:integer;
       function Glyph(Code:longword):PBeRoVectorCanvasTrueTypeGlyph;
       function Kerning(Left,Right:word;Horizontal:boolean):smallint;
       function CharacterMap(c:word):word; overload;
       function CharacterMap(c:widechar):word; overload;
       function NumContours(GlyphNum:word):smallint;
       function NumPoints(GlyphNum,ContourNum:word):smallint;
       function PointX(GlyphNum,ContourNum,PointNum:word):integer;
       function PointY(GlyphNum,ContourNum,PointNum:word):integer;
       function OnCurve(GlyphNum,ContourNum,PointNum:word):boolean;
       function GlyphXMin(GlyphNum:word):smallint;
       function GlyphYMin(GlyphNum:word):smallint;
       function GlyphXMax(GlyphNum:word):smallint;
       function GlyphYMax(GlyphNum:word):smallint;
     end;

{$ifdef cpu386}
function arctan2(const y,x:single):single; assembler; register;
asm
 fld dword ptr y
 fld dword ptr x
 fpatan
 fwait
end;
{$else}
function arctan(const x:double):double; {$ifdef caninline}inline;{$endif}
begin
 result:=0.05030176425872175099*(-6.9888366207752135+x)*(3.14559995508649281E-7+x)*((2.84446368839622429+0.826399783297673451*x)+(x*x))/(1+(0.1471039133652469065841349249*x)+(0.644464067689154755092299698*x*x));
end;

function arctan2(y,x:double):double; {$ifdef caninline}inline;{$endif}
begin
 if abs(x)<1e-12 then begin
  result:=0;
 end else begin
  result:=arctan(y/x);
 end;
end;
{$endif}

function SoftTRUNC(FloatValue:double):integer;
type TFLOAT64=packed record
{$IFDEF CPU386}
      Lo:longword;
      Hi:longword;
{$ELSE}
      Hi:longword;
      Lo:longword;
{$ENDIF}
     end;
var Exponent,Sig0,Sig1,SigExtra,Signed,IsDenormalized:longword;
    Value,Shift:integer;
    Float64:TFLOAT64 absolute FloatValue;
begin
 Sig0:=Float64.Hi and $000fffff;
 Sig1:=Float64.Lo;
 Exponent:=(Float64.Hi shr 20) and $7ff;
 Shift:=Exponent-$413;
 Sig0:=Sig0 or $100000;
 SigExtra:=((Sig0 shl Shift) or (Sig1 shr ((32-Shift) and 31)) and (-ord(Shift<0))) or (Sig0 and (-ord(Shift=0)));
 IsDenormalized:=-ord(0<=Shift);
 Value:=(((-ord(Exponent>=$3ff)) and (Sig0 shr (32-Shift))) and not IsDenormalized) or
        (SigExtra and IsDenormalized);
 Signed:=-ord((Float64.Hi and $80000000)<>0);
 result:=(((-Value) and Signed) or (Value and not Signed));
end;

function SoftROUND(FloatValue:double):integer;  {$ifdef caninline}inline;{$endif}
begin
 result:=SoftTRUNC(FloatValue+0.5);
end;

const MatrixIdentity:TBeRoVectorFontMatrix=(1,0,0,1,0,0);

function MatrixRotate(degress:double):TBeRoVectorFontMatrix; {$ifdef caninline}inline;{$endif}
var rad,c,s:double;
begin
 rad:=degress*deg2rad;
 c:=cos(rad);
 s:=sin(rad);
 result:=MatrixIdentity;
 result[0]:=c;
 result[1]:=s;
 result[2]:=-s;
 result[3]:=c;
end;

procedure ApplyMatrixToXY(const m:TBeRoVectorFontMatrix;var x,y:double); {$ifdef caninline}inline;{$endif}
var tx:double;
begin
 tx:=x;
 x:=(tx*m[0])+(y*m[2])+m[4];
 y:=(tx*m[1])+(y*m[3])+m[5];
end;

function toDOUBLE(x:longword):double;
var a:smallint;
    aw:word absolute a;
begin
 aw:=x div 65536;
 if a>0 then begin
  result:=aw+((x mod 65536)/$ffffffff);
 end else begin
  result:=aw-((x mod 65536)/$ffffffff);
 end;
end;

function toWORD(b1,b2:byte):word;
begin
 result:=(b1 shl 8) or b2;
end;

function toSMALLINT(b1,b2:byte):smallint;
begin
 result:=smallint(toWORD(b1,b2));
end;

function toLONGWORD(b1,b2,b3,b4:byte):longword;
begin
 result:=(b1 shl 24) or (b2 shl 16) or (b3 shl 8) or b4;
end;

function IsBitSet(ByteValue,Bit:byte):boolean;
begin
 result:=(ByteValue and (1 shl Bit))<>0;
end;

constructor TBeRoVectorFontTrueType.Create(DataPointer:pointer;DataSize:integer;pid,sid,lid:word);
begin
 inherited Create;
 platformID:=pid;
 specificID:=sid;
 languageID:=lid;
 fontDataSize:=0;
 fontData:=nil;
 cmap:=nil;
 cmapFormat:=0;
 numTables:=0;
 indexToLocFormat:=0;
 glyphs:=nil;
 glyphOffsetArray:=nil;
 strcopyright:='';
 strfamily:='';
 strsubfamily:='';
 strfullName:='';
 struniqueid:='';
 strversion:='';
 strpostscript:='';
 strtrademark:='';
 xMax:=0;
 xMin:=0;
 yMax:=0;
 yMin:=0;
 unitsPerEm:=0;
 ascender:=0;
 descender:=0;
 lineGap:=0;
 KerningTables:=nil;
 LastError:=TT_ERR_NoError;
 if ReadFontData(DataPointer,DataSize)=TT_ERR_NoError then begin
  if ProcessFontHeaderTable=TT_ERR_NoError then begin
   if ProcessMaximumProfileTable=TT_ERR_NoError then begin
    if ProcessIndexToLocationTable=TT_ERR_NoError then begin
     if ProcessCharacterMappingTable=TT_ERR_NoError then begin
      if ProcessNamingTable=TT_ERR_NoError then begin
       if ProcessGlyphDataTable=TT_ERR_NoError then begin
        if ProcessHorizontalHeaderTable=TT_ERR_NoError then begin
         if ProcessHorizontalMetricsTable=TT_ERR_NoError then begin
          if ProcessVerticalHeaderTable=TT_ERR_NoError then begin
           if ProcessVerticalMetricsTable=TT_ERR_NoError then begin
            if ProcessKerningTable<>TT_ERR_NoError then begin
             LastError:=TT_ERR_NoError; // Kerning table is only optional
            end;
           end;
          end;
         end;
        end;
       end;
      end;
     end;
    end;
   end;
  end;
 end;
end;

destructor TBeRoVectorFontTrueType.Destroy;
var i,j:integer;
begin
 for i:=0 to length(Glyphs)-1 do begin
  for j:=0 to length(Glyphs[i].Contours)-1 do begin
   setlength(Glyphs[i].Contours[j].Points,0);
  end;
  setlength(Glyphs[i].Contours,0);
 end;
 setlength(Glyphs,0);
 setlength(FontData,0);
 setlength(CMap,0);
 setlength(GlyphOffsetArray,0);
 for i:=0 to length(KerningTables)-1 do begin
  setlength(KerningTables[i].KerningPairs,0);
 end;
 setlength(KerningTables,0);
 inherited Destroy;
end;

function TBeRoVectorFontTrueType.ReadFontData(DataPointer:pointer;DataSize:integer):integer;
var i,tablelength,tabledirsize,tabledatasize:integer;
    tfd:array[0..OFFSET_TABLE_SIZE-1] of byte;
    tabledir:array of byte;
    DataPosition:integer;
 function read(var Buffer;LengthCounter:integer):integer;
 var RealSize:integer;
 begin
  RealSize:=LengthCounter;
  if (DataPosition+RealSize)>DataSize then begin
   RealSize:=DataSize-DataPosition;
  end;
  if RealSize<>LengthCounter then begin
   fillchar(Buffer,LengthCounter,#0);
  end;
  if RealSize>0 then begin
   move(PByteArray(DataPointer)^[DataPosition],Buffer,RealSize);
  end;
  inc(DataPosition,RealSize);
  result:=RealSize;
 end;
begin
 if not assigned(DataPointer) then begin
  LastError:=TT_ERR_UnableToOpenFile;
  result:=LastError;
  exit;
 end;

 DataPosition:=0;

 if read(tfd,OFFSET_TABLE_SIZE)<>OFFSET_TABLE_SIZE then begin
  LastError:=TT_ERR_CorruptFile;
  result:=LastError;
  exit;
 end;

 numTables:=toWORD(tfd[4],tfd[5]); // Get the number of Tables in this font
 tabledirsize:=sizeof(longword)*4*numTables; // Calculate size of Table Directory
 tabledir:=nil;
 setlength(tabledir,tabledirsize);              // Allocate storage for Table Directory
 if length(tabledir)<>tabledirsize then begin
  LastError:=TT_ERR_OutOfMemory;
  result:=LastError;
  exit;
 end;

 tabledatasize:=0;
 i:=0;
 while i<tabledirsize do begin
  if read(tabledir[i],16)<>16 then begin
   setlength(tabledir,0);
   LastError:=TT_ERR_CorruptFile;
   result:=LastError;
   exit;
  end;
  tablelength:=toLONGWORD(tabledir[i+12],tabledir[i+13],tabledir[i+14],tabledir[i+15]);
  if (tablelength and 3)<>0 then begin
   inc(tablelength,4-(tablelength and 3));
  end;
  inc(tabledatasize,tablelength);
  inc(i,16);
 end;

 fontDataSize:=OFFSET_TABLE_SIZE+tabledirsize+tabledatasize; // Calculate size of entire font file
 setlength(fontData,fontDataSize); // Allocate space for all that data
 if length(fontData)<>fontDataSize then begin
  setlength(tabledir,0);
  LastError:=TT_ERR_OutOfMemory;
  result:=LastError;
  exit;
 end;
 fillchar(fontData[0],fontDataSize,#0);

 move(tfd[0],fontData[0],OFFSET_TABLE_SIZE); // Store the Offset Table
 move(tabledir[0],fontData[OFFSET_TABLE_SIZE],tabledirsize); // Store the Offset Table
 if read(fontData[OFFSET_TABLE_SIZE+tabledirsize],(fontDataSize-(OFFSET_TABLE_SIZE+tabledirsize)))<>((fontDataSize-(OFFSET_TABLE_SIZE+tabledirsize))) then begin // Store the rest of the font
{ setlength(tabledir,0);
  setlength(fontData,0);
  fontDataSize:=0;
  LastError:=TT_ERR_CorruptFile;
  result:=LastError;
  exit;}
 end;

 setlength(tabledir,0);

 LastError:=TT_ERR_NoError;
 result:=LastError;
end;

function TBeRoVectorFontTrueType.GetTableDirEntry(Tag:longword;var CheckSum,Offset,Size:longword):integer;
var i:integer;
    pos,currenttag:longword;
    found:boolean;
begin
 pos:=OFFSET_TABLE_SIZE;
 found:=false;
 for i:=0 to numTables-1 do begin
  currenttag:=toLONGWORD(fontData[pos],fontData[pos+1],fontData[pos+2],fontData[pos+3]);
  if currenttag=Tag then begin
   CheckSum:=toLONGWORD(fontData[pos+4],fontData[pos+5],fontData[pos+6],fontData[pos+7]);
   Offset:=toLONGWORD(fontData[pos+8],fontData[pos+9],fontData[pos+10],fontData[pos+11]);
   Size:=toLONGWORD(fontData[pos+12],fontData[pos+13],fontData[pos+14],fontData[pos+15]);
   found:=true;
   break;
  end;
  inc(pos,16);
 end;
 if found then begin
  LastError:=TT_ERR_NoError;
 end else begin
  LastError:=TT_ERR_TableNotFound;
 end;
 result:=LastError;
end;

function TBeRoVectorFontTrueType.ProcessFontHeaderTable:integer;
var pos,tag,checksum,offset,size,MagicNumber:longword;
begin
 tag:=toLONGWORD(byte('h'),byte('e'),byte('a'),byte('d'));
 result:=GetTableDirEntry(Tag,checksum,offset,size);
 if result<>TT_Err_NoError then exit;
 pos:=offset;
 inc(pos,sizeof(longword)); // Table version number
 inc(pos,sizeof(longword)); // Font revision number
 inc(pos,sizeof(longword)); // Checksum adjustment
 MagicNumber:=toLONGWORD(fontData[pos],fontData[pos+1],fontData[pos+2],fontData[pos+3]);
 inc(pos,sizeof(longword)); // Magic number
 if MagicNumber<>$5F0F3CF5 then begin
  LastError:=TT_ERR_InvalidFile;
  result:=LastError;
  exit;
 end;
 inc(pos,sizeof(word)); // Flags
 unitsPerEm:=toWORD(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(word));
 inc(pos,8); // Date created
 inc(pos,8); // Date modified
 xMin:=toSMALLINT(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(smallint));
 yMin:=toSMALLINT(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(smallint));
 xMax:=toSMALLINT(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(smallint));
 yMax:=toSMALLINT(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(smallint));
 inc(pos,sizeof(word)); // Mac-style
 inc(pos,sizeof(word)); // Lowest rec pen
 inc(pos,sizeof(smallint)); // Font direction hint
 indexToLocFormat:=toSMALLINT(fontData[pos],fontData[pos+1]);
//inc(pos,sizeof(smallint));
 LastError:=TT_ERR_NoError;
 result:=LastError;
end;

function TBeRoVectorFontTrueType.ProcessMaximumProfileTable:integer;
var pos,tag,checksum,offset,size:longword;
    n:word;
    i:integer;
begin
 tag:=toLONGWORD(byte('m'),byte('a'),byte('x'),byte('p'));
 result:=GetTableDirEntry(Tag,checksum,offset,size);
 if result<>TT_Err_NoError then exit;
 pos:=offset;
 inc(pos,sizeof(longword)); // Table Version number
 n:=toWORD(fontData[pos],fontData[pos+1]);
//inc(pos,sizeof(word));
 setlength(Glyphs,n);
 if length(Glyphs)<>n then begin
  LastError:=TT_ERR_OutOfMemory;
  result:=LastError;
  exit;
 end;
 for i:=0 to length(Glyphs)-1 do begin
  fillchar(Glyphs[i],sizeof(TBeRoVectorFontTrueTypeGlyph),#0);
 end;
 LastError:=TT_ERR_NoError;
 result:=LastError;
end;

function TBeRoVectorFontTrueType.ProcessNamingTable:integer;
var pos,tag,checksum,offset,size,numNameRecords,stringStorageOffset,i,j:longword;
    thisPlatformID,thisSpecificID,thisLanguageID,thisNameID,thisStringLength,thisStringOffset:word;
    namefound:boolean;
    ws:^widestring;
    s:string;
begin
 tag:=toLONGWORD(byte('n'),byte('a'),byte('m'),byte('e'));
 result:=GetTableDirEntry(Tag,checksum,offset,size);
 if result<>TT_Err_NoError then exit;
 pos:=offset;
 inc(pos,sizeof(word)); // Format Selector
 numNameRecords:=toWORD(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(word));
 stringStorageOffset:=toWORD(fontData[pos],fontData[pos+1])+offset;
 inc(pos,sizeof(word));
 for i:=1 to numNameRecords do begin
  thisPlatformID:=toWORD(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(word));
  thisSpecificID:=toWORD(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(word));
  thisLanguageID:=toWORD(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(word));
  thisNameID:=toWORD(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(word));
  thisStringLength:=toWORD(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(word));
  thisStringOffset:=toWORD(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(word));
  if (thisPlatformID<>PlatformID) or (thisSpecificID<>SpecificID) or (thisLanguageID<>LanguageID) then begin
   continue;
  end;
  namefound:=false;
  ws:=nil;
  case thisNameID of
   NID_Copyright:begin
    namefound:=true;
    ws:=@strcopyright;
   end;
   NID_Family:begin
    namefound:=true;
    ws:=@strfamily;
   end;
   NID_Subfamily:begin
    namefound:=true;
    ws:=@strsubfamily;
   end;
   NID_UniqueID:begin
    namefound:=true;
    ws:=@struniqueid;
   end;
   NID_FullName:begin
    namefound:=true;
    ws:=@strfullname;
   end;
   NID_Version:begin
    namefound:=true;
    ws:=@strversion;
   end;
   NID_PostscriptName:begin
    namefound:=true;
    ws:=@strpostscript;
   end;
   NID_Trademark:begin
    namefound:=true;
    ws:=@strtrademark;
   end;
  end;
  if namefound then begin
   case ThisPlatformID of
    PID_Microsoft:begin
     setlength(ws^,thisStringLength div 2);
     if length(ws^)<>(thisStringLength div 2) then begin
      LastError:=TT_ERR_OutOfMemory;
      result:=LastError;
      exit;
     end;
//   move(fontData[stringStorageOffset+thisStringOffset],ws^[1],thisStringLength{div 2});
     j:=0;
     while j<thisStringLength do begin
      ws^[(j div 2)+1]:=widechar(word((fontData[stringStorageOffset+thisStringOffset+j] shl 8) or fontData[stringStorageOffset+thisStringOffset+j+1]));
      inc(j,2);
     end;
    end;
    else begin
     setlength(ws^,thisStringLength);
     if length(ws^)<>thisStringLength then begin
      LastError:=TT_ERR_OutOfMemory;
      result:=LastError;
      exit;
     end;
     setlength(s,thisStringLength);
     if length(s)<>thisStringLength then begin
      LastError:=TT_ERR_OutOfMemory;
      result:=LastError;
      exit;
     end;
     move(fontData[stringStorageOffset+thisStringOffset],s[1],thisStringLength);
     ws^:=s;
    end;
   end;
  end;
 end;
 LastError:=TT_ERR_NoError;
 result:=LastError;
end;

function TBeRoVectorFontTrueType.ProcessIndexToLocationTable:integer;
var pos,tag,checksum,offset,size,thisOffset:longword;
    i:integer;
begin
 tag:=toLONGWORD(byte('l'),byte('o'),byte('c'),byte('a'));
 result:=GetTableDirEntry(Tag,checksum,offset,size);
 if result<>TT_Err_NoError then exit;
 pos:=offset;
 setlength(glyphOffsetArray,length(glyphs)+1);
 if length(glyphOffsetArray)<>(length(glyphs)+1) then begin
  LastError:=TT_ERR_OutOfMemory;
  result:=LastError;
  exit;
 end;
 thisOffset:=0;
 for i:=0 to length(glyphs) do begin
  case indexToLocFormat of
   0:begin
    thisOffset:=toWORD(fontData[pos],fontData[pos+1])*2;
    inc(pos,sizeof(word));
   end;
   1:begin
    thisOffset:=toLONGWORD(fontData[pos],fontData[pos+1],fontData[pos+2],fontData[pos+3]);
    inc(pos,sizeof(longword));
   end;
   else begin
    LastError:=TT_ERR_CorruptFile;
    result:=LastError;
    exit;
   end;
  end;
  glyphOffsetArray[i]:=thisOffset;
 end;
 LastError:=TT_ERR_NoError;
 result:=LastError;
end;

function TBeRoVectorFontTrueType.ProcessGlyphDataTable:integer;
const ARGS_ARE_WORDS=$0001;
      ARGS_ARE_XY_VALUES=$0002;
      ROUND_XY_TO_GRID=$0004;
      WE_HAVE_A_SCALE=$0008;
      MORE_COMPONENTS=$0020;
      WE_HAVE_AN_XY_SCALE=$0040;
      WE_HAVE_A_2X2=$0080;
      WE_HAVE_INSTR=$0100;
      USE_MY_METRICS=$0200;
      OVERLAP_COMPOUND=$0400;
      SCALED_COMPONENT_OFFSET=$0800;
      UNSCALED_COMPONENT_OFFSET=$1000;
type pgflags=^tgflags;
     tgflags=array[word] of boolean;
var cflags,cindex,ccount,pos,tag,checksum,offset,size,thisOffset,currGlyphOffset,nextGlyphOffset,currGlyphLength,instructionLength:longword;
    i,j,carg1,carg2,cxx,cyx,cxy,cyy,currentFlag,gi,numContours,numberOfPoints,repeatcount,startPoint,endPoint,xbyte,ybyte,xword,yword,tx,ty:integer;
    endPtsOfContours:array of word;
    flags:array of byte;
    gflags:pgflags;
 procedure ProcessGlyph(gi:integer);
  function MulFix(a,b:integer):integer;
  var s:integer;
  begin
   s:=1;
   if a<0 then begin
    a:=-a;
    s:=-1;
   end;
   if b<0 then begin
    b:=-b;
    s:=-s;
   end;
   result:=((int64(a)*int64(b))+$8000) div 65536;
   if s<0 then begin
    result:=-result;
   end;
  end;
  procedure Transform(var x,y:integer;xx,yx,xy,yy:integer);
  var xz,yz:integer;
  begin
   xz:=MulFix(x,xx)+MulFix(y,xy);
   yz:=MulFix(x,yx)+MulFix(y,yy);
   x:=xz;
   y:=yz;
  end;
  procedure GetPointXY(gi,pi:integer;var x,y:integer);
  var i,j:integer;
  begin
   x:=0;
   y:=0;
   j:=0;
   for i:=0 to length(Glyphs[gi].Contours)-1 do begin
    if (pi-j)<length(Glyphs[gi].Contours[i].Points) then begin
     x:=Glyphs[gi].Contours[i].Points[pi-j].x;
     y:=Glyphs[gi].Contours[i].Points[pi-j].y;
     exit;
    end;
    inc(j,length(Glyphs[gi].Contours[i].Points));
   end;
  end;
  procedure ProcessSubGlyph(tgi:integer;const sg:TBeRoVectorFontTrueTypeCompositeSubGlyph;x,y,xx,yx,xy,yy,p1c,p2c:integer);
  var HaveScale:boolean;
      tgip1,sgpc,ps,pe,tgic1,sgcc,i,j,k,p1,p2,cs,ce,cx,cy,p1x,p1y,p2x,p2y:integer;
      mxs,mys:double;
  begin
   if tgi=124 then begin
    if tgi=124 then begin
    end;
   end;
   tgip1:=length(Glyphs[tgi].Points);
   sgpc:=length(Glyphs[sg.Glyph].Points);
   setlength(Glyphs[tgi].Points,tgip1+sgpc);
   ps:=tgip1;
   pe:=tgip1+sgpc-1;
   for i:=ps to pe do begin
    Glyphs[tgi].Points[i]:=Glyphs[sg.Glyph].Points[i-tgip1];
   end;
   tgic1:=length(Glyphs[tgi].Contours);
   sgcc:=length(Glyphs[sg.Glyph].Contours);
   setlength(Glyphs[tgi].Contours,tgic1+sgcc);
   cs:=tgic1;
   ce:=tgic1+sgcc-1;
   for i:=cs to ce do begin
    Glyphs[tgi].Contours[i].Points:=copy(Glyphs[sg.Glyph].Contours[i-tgic1].Points,0,length(Glyphs[sg.Glyph].Contours[i-tgic1].Points));
   end;
   HaveScale:=(sg.Flags and (WE_HAVE_A_SCALE or WE_HAVE_AN_XY_SCALE or WE_HAVE_A_2X2))<>0;
   if HaveScale then begin
    for i:=ps to pe do begin
     Transform(Glyphs[tgi].Points[i].x,Glyphs[tgi].Points[i].y,xx,yx,xy,yy);
    end;
    for i:=cs to ce do begin
     for j:=0 to length(Glyphs[tgi].Contours[i].Points)-1 do begin
      Transform(Glyphs[tgi].Contours[i].Points[j].X,Glyphs[tgi].Contours[i].Points[j].Y,xx,yx,xy,yy);
     end;
    end;
   end;
   if (sg.Flags and ARGS_ARE_XY_VALUES)<>0 then begin
    cx:=sg.x;
    cy:=sg.y;
   end else begin
    p1:=sg.x;
    p2:=sg.y;//+ps;
    if (p1>=0) and (p2>=0) and (p1<ps) and (p2<length(Glyphs[tgi].Points)) then begin
     p1x:=Glyphs[tgi].Points[p1].x;
     p1y:=Glyphs[tgi].Points[p1].y;
     p2x:=Glyphs[tgi].Points[p2].x;
     p2y:=Glyphs[tgi].Points[p2].y;
     cx:=p1x-p2x;
     cy:=p1y-p2y;
    end else begin
     cx:=0;
     cy:=0;
    end;
   end;
   if (cx<>0) or (cy<>0) then begin
    if HaveScale and ((sg.Flags and UNSCALED_COMPONENT_OFFSET)=0) then begin
     mxs:=sqrt(sqr(sg.xx/65536)+sqr(sg.xy/65536));
     mys:=sqrt(sqr(sg.yx/65536)+sqr(sg.yy/65536));
     cx:=round((cx*mxs)*65536);
     cy:=round((cy*mys)*65536);
    end;
   end;
   if (sg.Flags and ROUND_XY_TO_GRID)<>0 then begin
    cx:=round(cx/65536)*65536;
    cy:=round(cy/65536)*65536;
   end;
   if (cx<>0) or (cy<>0) then begin
    for i:=ps to pe do begin
     inc(Glyphs[tgi].Points[i].x,cx);
     inc(Glyphs[tgi].Points[i].y,cy);
    end;
    for i:=cs to ce do begin
     for j:=0 to length(Glyphs[tgi].Contours[i].Points)-1 do begin
      inc(Glyphs[tgi].Contours[i].Points[j].X,cx);
      inc(Glyphs[tgi].Contours[i].Points[j].Y,cy);
     end;
    end;
   end;
  end;
  procedure ProcessGlyphEx(tgi,cgi,x,y,xx,yx,xy,yy:integer);
  var i,p1,p2:integer;
  begin
   if gflags^[cgi] then exit;
   gflags^[cgi]:=true;
   p1:=0;
   for i:=0 to length(Glyphs[gi].CompositeSubGlyphs)-1 do begin
    p2:=p1;
    p1:=length(Glyphs[gi].Points);
    ProcessSubGlyph(tgi,Glyphs[gi].CompositeSubGlyphs[i],x,y,xx,yx,xy,yy,p1,p2);
   end;
   gflags^[cgi]:=false;
  end;
 begin
  ProcessGlyphEx(gi,gi,0,0,$10000,0,0,$10000);
  setlength(Glyphs[gi].CompositeSubGlyphs,0);
 end;
begin
 endPtsOfContours:=nil;
 flags:=nil;
 tag:=toLONGWORD(byte('g'),byte('l'),byte('y'),byte('f'));
 result:=GetTableDirEntry(Tag,checksum,offset,size);
 if result<>TT_Err_NoError then exit;
 for gi:=0 to length(Glyphs)-1 do begin
  currGlyphOffset:=glyphOffsetArray[gi];
  nextGlyphOffset:=glyphOffsetArray[gi+1];
  currGlyphLength:=nextGlyphOffset-currGlyphOffset;
  if currGlyphLength=0 then begin
   glyphs[gi].Contours:=nil;
   glyphs[gi].CompositeSubGlyphs:=nil;
   glyphs[gi].xMin:=0;
   glyphs[gi].yMin:=0;
   glyphs[gi].xMax:=0;
   glyphs[gi].yMax:=0;
   continue;
  end;
  pos:=offset+currGlyphOffset;
  numContours:=toSMALLINT(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(smallint));
  glyphs[gi].xMin:=toSMALLINT(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(smallint));
  glyphs[gi].yMin:=toSMALLINT(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(smallint));
  glyphs[gi].xMax:=toSMALLINT(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(smallint));
  glyphs[gi].yMax:=toSMALLINT(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(smallint));
  if numContours<=0 then begin
   glyphs[gi].Contours:=nil;
   glyphs[gi].CompositeSubGlyphs:=nil;
   if numContours=-1 then begin
    repeat
     i:=length(glyphs[gi].CompositeSubGlyphs);
     setlength(glyphs[gi].CompositeSubGlyphs,i+1);
     cflags:=toWORD(fontData[pos],fontData[pos+1]);
     inc(pos,sizeof(word));
     cindex:=toWORD(fontData[pos],fontData[pos+1]);
     inc(pos,sizeof(word));
     ccount:=2;
     if (cflags and ARGS_ARE_WORDS)<>0 then begin
      inc(ccount,2);
     end;
     if (cflags and WE_HAVE_A_SCALE)<>0 then begin
      inc(ccount,2);
     end else if (cflags and WE_HAVE_AN_XY_SCALE)<>0 then begin
      inc(ccount,4);
     end else if (cflags and WE_HAVE_A_2X2)<>0 then begin
      inc(ccount,8);
     end;
     if (cflags and ARGS_ARE_WORDS)<>0 then begin
      carg1:=toSMALLINT(fontData[pos],fontData[pos+1]);
      inc(pos,sizeof(smallint));
      carg2:=toSMALLINT(fontData[pos],fontData[pos+1]);
      inc(pos,sizeof(smallint));
     end else begin
      carg1:=SHORTINT(fontData[pos]);
      inc(pos);
      carg2:=SHORTINT(fontData[pos]);
      inc(pos);
     end;
     cxx:=$10000;
     cyy:=$10000;
     cxy:=0;
     cyx:=0;
     if (cflags and WE_HAVE_A_SCALE)<>0 then begin
      cxx:=toSMALLINT(fontData[pos],fontData[pos+1])*4;
      inc(pos,sizeof(smallint));
      cyy:=cxx;
     end else if (cflags and WE_HAVE_AN_XY_SCALE)<>0 then begin
      cxx:=toSMALLINT(fontData[pos],fontData[pos+1])*4;
      inc(pos,sizeof(smallint));
      cyy:=toSMALLINT(fontData[pos],fontData[pos+1])*4;
      inc(pos,sizeof(smallint));
     end else if (cflags and WE_HAVE_A_2X2)<>0 then begin
      cxx:=toSMALLINT(fontData[pos],fontData[pos+1])*4;
      inc(pos,sizeof(smallint));
      cyx:=toSMALLINT(fontData[pos],fontData[pos+1])*4;
      inc(pos,sizeof(smallint));
      cxy:=toSMALLINT(fontData[pos],fontData[pos+1])*4;
      inc(pos,sizeof(smallint));
      cyy:=toSMALLINT(fontData[pos],fontData[pos+1])*4;
      inc(pos,sizeof(smallint));
     end;
     glyphs[gi].CompositeSubGlyphs[i].Glyph:=cindex;
     glyphs[gi].CompositeSubGlyphs[i].x:=carg1;
     glyphs[gi].CompositeSubGlyphs[i].y:=carg2;
     glyphs[gi].CompositeSubGlyphs[i].xx:=cxx;
     glyphs[gi].CompositeSubGlyphs[i].yx:=cyx;
     glyphs[gi].CompositeSubGlyphs[i].xy:=cxy;
     glyphs[gi].CompositeSubGlyphs[i].yy:=cyy;
    until (cflags and MORE_COMPONENTS)=0;
   end;
   continue;
  end;
  glyphs[gi].CompositeSubGlyphs:=nil;
  setlength(glyphs[gi].Contours,numContours);
  if length(glyphs[gi].Contours)<>numContours then begin
   LastError:=TT_ERR_OutOfMemory;
   result:=LastError;
   exit;
  end;
  setlength(endPtsOfContours,numContours);
  if length(endPtsOfContours)<>numContours then begin
   LastError:=TT_ERR_OutOfMemory;
   result:=LastError;
   exit;
  end;
  for i:=0 to length(endPtsOfContours)-1 do begin
   endPtsOfContours[i]:=toWORD(fontData[pos],fontData[pos+1]);
   inc(pos,sizeof(word));
  end;
  numberOfPoints:=endPtsOfContours[length(endPtsOfContours)-1]+1;
  instructionLength:=toWORD(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(word));
  inc(pos,instructionLength);
  setlength(flags,numberOfPoints);
  if length(flags)<>numberOfPoints then begin
   LastError:=TT_ERR_OutOfMemory;
   result:=LastError;
   exit;
  end;
  i:=0;
  while i<numberOfPoints do begin
   flags[i]:=fontData[pos];
   inc(pos);
   if (flags[i] and 8)<>0 then begin
    repeatcount:=fontData[pos];
    inc(pos);
    while repeatcount>0 do begin
     inc(i);
     flags[i]:=flags[i-1];
     dec(repeatcount);
    end;
   end;
   inc(i);
  end;
  setlength(glyphs[gi].Points,numberOfPoints);
  for i:=0 to numberOfPoints-1 do begin
   currentFlag:=flags[i];
   glyphs[gi].Points[i].OnCurve:=(currentFlag and 1)<>0;
   if (currentFlag and 2)<>0 then begin
    xByte:=fontData[pos];
    inc(pos);
    if (currentFlag and 16)<>0 then begin
     glyphs[gi].Points[i].x:=xbyte;
    end else begin
     glyphs[gi].Points[i].x:=-xbyte;
    end;
   end else begin
    if (currentFlag and 16)<>0 then begin
     glyphs[gi].Points[i].x:=0;
    end else begin
     xword:=toSMALLINT(fontData[pos],fontData[pos+1]);
     inc(pos,sizeof(smallint));
     glyphs[gi].Points[i].x:=xword;
    end;
   end;
  end;
  for i:=0 to numberOfPoints-1 do begin
   currentFlag:=flags[i];
   if (currentFlag and 4)<>0 then begin
    yByte:=fontData[pos];
    inc(pos);
    if (currentFlag and 32)<>0 then begin
     glyphs[gi].Points[i].y:=ybyte;
    end else begin
     glyphs[gi].Points[i].y:=-ybyte;
    end;
   end else begin
    if (currentFlag and 32)<>0 then begin
     glyphs[gi].Points[i].y:=0;
    end else begin
     yword:=toSMALLINT(fontData[pos],fontData[pos+1]);
     inc(pos,sizeof(smallint));
     glyphs[gi].Points[i].y:=yword;
    end;
   end;
  end;
  startPoint:=0;
  for i:=0 to numContours-1 do begin
   endPoint:=endPtsOfContours[i];
   setlength(glyphs[gi].contours[i].Points,endPoint-startPoint+1);
   if length(glyphs[gi].contours[i].Points)<>(endPoint-startPoint+1) then begin
    LastError:=TT_ERR_OutOfMemory;
    result:=LastError;
    exit;
   end;
   for j:=startpoint to endpoint do begin
    glyphs[gi].contours[i].Points[j-startPoint]:=glyphs[gi].Points[j];
   end;
   startPoint:=endPoint+1;
  end;
{ startPoint:=0;
  for i:=0 to numContours-1 do begin
   endPoint:=endPtsOfContours[i];
   setlength(glyphs[gi].contours[i].Points,endPoint-startPoint+1);
   if length(glyphs[gi].contours[i].Points)<>(endPoint-startPoint+1) then begin
    LastError:=TT_ERR_OutOfMemory;
    result:=LastError;
    exit;
   end;
   for j:=startpoint to endpoint do begin
    currentFlag:=flags[j];
    glyphs[gi].contours[i].Points[j-startPoint].OnCurve:=(currentFlag and 1)<>0;
    if (currentFlag and 2)<>0 then begin
     xByte:=fontData[pos];
     inc(pos);
     if (currentFlag and 16)<>0 then begin
      glyphs[gi].contours[i].Points[j-startPoint].x:=xbyte;
     end else begin
      glyphs[gi].contours[i].Points[j-startPoint].x:=-xbyte;
     end;
    end else begin
     if (currentFlag and 16)<>0 then begin
      glyphs[gi].contours[i].Points[j-startPoint].x:=0;
     end else begin
      xword:=toSMALLINT(fontData[pos],fontData[pos+1]);
      inc(pos,sizeof(smallint));
      glyphs[gi].contours[i].Points[j-startPoint].x:=xword;
     end;
    end;
   end;
   startPoint:=endPoint+1;
  end;
  startPoint:=0;
  for i:=0 to numContours-1 do begin
   endPoint:=endPtsOfContours[i];
   for j:=startpoint to endpoint do begin
    currentFlag:=flags[j];
    if (currentFlag and 4)<>0 then begin
     yByte:=fontData[pos];
     inc(pos);
     if (currentFlag and 32)<>0 then begin
      glyphs[gi].contours[i].Points[j-startPoint].y:=ybyte;
     end else begin
      glyphs[gi].contours[i].Points[j-startPoint].y:=-ybyte;
     end;
    end else begin
     if (currentFlag and 32)<>0 then begin
      glyphs[gi].contours[i].Points[j-startPoint].y:=0;
     end else begin
      yword:=toSMALLINT(fontData[pos],fontData[pos+1]);
      inc(pos,sizeof(smallint));
      glyphs[gi].contours[i].Points[j-startPoint].y:=yword;
     end;
    end;
   end;
   startPoint:=endPoint+1;
  end;}
 end;
 setlength(endPtsOfContours,0);
 setlength(flags,0);
 for gi:=0 to length(Glyphs)-1 do begin
  tx:=0;
  ty:=0;
  for i:=0 to length(glyphs[gi].Contours)-1 do begin
   for j:=0 to length(glyphs[gi].Contours[i].Points)-1 do begin
    inc(tx,glyphs[gi].Contours[i].Points[j].x);
    inc(ty,glyphs[gi].Contours[i].Points[j].y);
    glyphs[gi].Contours[i].Points[j].x:=tx;
    glyphs[gi].Contours[i].Points[j].y:=ty;
   end;
  end;
 end;
 new(gflags);
 fillchar(gflags^,sizeof(tgflags),#0);
 for gi:=0 to length(Glyphs)-1 do begin
  ProcessGlyph(gi);
 end;
 dispose(gflags);
 LastError:=TT_ERR_NoError;
 result:=LastError;
end;

function TBeRoVectorFontTrueType.ProcessHorizontalHeaderTable:integer;
var pos,tag,checksum,offset,size:longword;
begin
 tag:=toLONGWORD(byte('h'),byte('h'),byte('e'),byte('a'));
 result:=GetTableDirEntry(Tag,checksum,offset,size);
 if result<>TT_Err_NoError then begin
  tag:=toLONGWORD(byte('v'),byte('h'),byte('e'),byte('a'));
  result:=GetTableDirEntry(Tag,checksum,offset,size);
  exit;
 end;
 pos:=offset;
 inc(pos,sizeof(longword)); // Table Version number
 ascender:=toSMALLINT(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(smallint));
 descender:=toSMALLINT(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(smallint));
 lineGap:=toSMALLINT(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(smallint));
 AdvanceWidthMax:=toWORD(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(word));
 inc(pos,sizeof(smallint)); // MinLeftSideBearing
 inc(pos,sizeof(smallint)); // MinRightSideBearing
 inc(pos,sizeof(smallint)); // XMaxExtent
 inc(pos,sizeof(smallint)); // CaretSlopeRise
 inc(pos,sizeof(smallint)); // CaretSlopeRun
 inc(pos,sizeof(word)*5); // 5 reserved words
 inc(pos,sizeof(smallint)); // MetricDataFormat
 numberOfHMetrics:=toWORD(fontData[pos],fontData[pos+1]);
 LastError:=TT_ERR_NoError;
 result:=LastError;
end;

function TBeRoVectorFontTrueType.ProcessHorizontalMetricsTable:integer;
var pos,tag,checksum,offset,size:longword;
    i,j:integer;
begin
 tag:=toLONGWORD(byte('h'),byte('m'),byte('t'),byte('x'));
 result:=GetTableDirEntry(Tag,checksum,offset,size);
 if result<>TT_Err_NoError then begin
  tag:=toLONGWORD(byte('v'),byte('m'),byte('t'),byte('x'));
  result:=GetTableDirEntry(Tag,checksum,offset,size);
  exit;
 end;
 pos:=offset;
 i:=0;
 while i<NumberOfHMetrics do begin
  glyphs[i].AdvanceWidth:=toWORD(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(word));
  glyphs[i].LeftSideBearing:=toSMALLINT(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(smallint));
  glyphs[i].RightSideBearing:=glyphs[i].AdvanceWidth-(glyphs[i].LeftSideBearing+glyphs[i].xmax-glyphs[i].xmin);
  inc(i);
 end;
 if numberOfHMetrics=length(glyphs) then begin
  result:=LastError;
  exit;
 end;
 j:=glyphs[i-1].AdvanceWidth;
 i:=0;
 while i<length(Glyphs) do begin
  glyphs[i].AdvanceWidth:=j;
  glyphs[i].LeftSideBearing:=toSMALLINT(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(smallint));
  glyphs[i].RightSideBearing:=glyphs[i].AdvanceWidth-(glyphs[i].LeftSideBearing+glyphs[i].xmax-glyphs[i].xmin);
  inc(i);
 end;
 LastError:=TT_ERR_NoError;
 result:=LastError;
end;

function TBeRoVectorFontTrueType.ProcessVerticalHeaderTable:integer;
var pos,tag,checksum,offset,size:longword;
begin
 tag:=toLONGWORD(byte('v'),byte('h'),byte('e'),byte('a'));
 result:=GetTableDirEntry(Tag,checksum,offset,size);
 if result<>TT_Err_NoError then begin
  tag:=toLONGWORD(byte('h'),byte('h'),byte('e'),byte('a'));
  result:=GetTableDirEntry(Tag,checksum,offset,size);
  exit;
 end;
 pos:=offset;
 inc(pos,sizeof(longword)); // Table Version number
 ascender:=toSMALLINT(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(smallint));
 descender:=toSMALLINT(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(smallint));
 lineGap:=toSMALLINT(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(smallint));
 AdvanceHeightMax:=toWORD(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(word));
 inc(pos,sizeof(smallint)); // MinTopSideBearing
 inc(pos,sizeof(smallint)); // MinBottomSideBearing
 inc(pos,sizeof(smallint)); // YMaxExtent
 inc(pos,sizeof(smallint)); // CaretSlopeRise
 inc(pos,sizeof(smallint)); // CaretSlopeRun
 inc(pos,sizeof(word)*5); // 5 reserved words
 inc(pos,sizeof(smallint)); // MetricDataFormat
 numberOfVMetrics:=toWORD(fontData[pos],fontData[pos+1]);
 LastError:=TT_ERR_NoError;
 result:=LastError;
end;

function TBeRoVectorFontTrueType.ProcessVerticalMetricsTable:integer;
var pos,tag,checksum,offset,size:longword;
    i,j:integer;
begin
 tag:=toLONGWORD(byte('v'),byte('m'),byte('t'),byte('x'));
 result:=GetTableDirEntry(Tag,checksum,offset,size);
 if result<>TT_Err_NoError then begin
  tag:=toLONGWORD(byte('h'),byte('m'),byte('t'),byte('x'));
  result:=GetTableDirEntry(Tag,checksum,offset,size);
  exit;
 end;
 pos:=offset;
 i:=0;
 while i<NumberOfVMetrics do begin
  glyphs[i].AdvanceHeight:=toWORD(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(word));
  glyphs[i].TopSideBearing:=toSMALLINT(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(smallint));
  glyphs[i].BottomSideBearing:=glyphs[i].AdvanceHeight-(glyphs[i].TopSideBearing+glyphs[i].ymax-glyphs[i].ymin);
  inc(i);
 end;
 if numberOfVMetrics=length(glyphs) then begin
  result:=LastError;
  exit;
 end;
 j:=glyphs[i-1].AdvanceHeight;
 i:=0;
 while i<length(Glyphs) do begin
  glyphs[i].AdvanceWidth:=j;
  glyphs[i].TopSideBearing:=toSMALLINT(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(smallint));
  glyphs[i].BottomSideBearing:=glyphs[i].AdvanceHeight-(glyphs[i].TopSideBearing+glyphs[i].ymax-glyphs[i].ymin);
  inc(i);
 end;
 LastError:=TT_ERR_NoError;
 result:=LastError;
end;

function TBeRoVectorFontTrueType.ProcessKerningTable:integer;
var pos,tag,checksum,offset,size,v1,v2,SubTableSize,Next:longword;
    NumberOfSubTables,i,j,NumKerningPairs:integer;
    CoverageFormat,CoverageFlags:byte;
    DoNeedSort:boolean;
 procedure QuickSort(var KerningPairs:TBeRoVectorFontTrueTypeKerningPairs;l,r:integer);
 var i,j:integer;
     p,t:TBeRoVectorFontTrueTypeKerningPair;
     pv:longword;
 begin
  repeat
   i:=l;
   j:=r;
   p:=KerningPairs[(l+r) div 2];
   pv:=((p.Left shl 16) or p.Right);
   repeat
    while ((KerningPairs[i].Left shl 16) or KerningPairs[i].Right)<pv do inc(i);
    while ((KerningPairs[j].Left shl 16) or KerningPairs[j].Right)>pv do dec(j);
    if i<=j then begin
     t:=KerningPairs[i];
     KerningPairs[i]:=KerningPairs[j];
     KerningPairs[j]:=t;
     inc(i);
     dec(j);
    end;
   until i>j;
   if l<j then begin
    QuickSort(KerningPairs,l,j);
   end;
   l:=i;
  until i>=r;
 end;
 procedure BeRoSort(var KerningPairs:TBeRoVectorFontTrueTypeKerningPairs);
 var i:integer;
     t:TBeRoVectorFontTrueTypeKerningPair;
 begin
  i:=0;
  while i<length(KerningPairs)-1 do begin
   if ((KerningPairs[i].Left shl 16) or KerningPairs[i].Right)>((KerningPairs[i+1].Left shl 16) or KerningPairs[i+1].Right) then begin
    t:=KerningPairs[i];
    KerningPairs[i]:=KerningPairs[i+1];
    KerningPairs[i+1]:=t;
    if i>0 then begin
     dec(i);
    end else begin
     inc(i);
    end;
   end else begin
    inc(i);
   end;
  end;
 end;
begin
 tag:=toLONGWORD(byte('k'),byte('e'),byte('r'),byte('n'));
 result:=GetTableDirEntry(Tag,checksum,offset,size);
 if result<>TT_Err_NoError then exit;
 pos:=offset;
 inc(pos,sizeof(word)); // Table Version number
 NumberOfSubTables:=toWORD(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(word));

 setlength(KerningTables,NumberOfSubTables);
 if length(KerningTables)<>NumberOfSubTables then begin
  LastError:=TT_ERR_OutOfMemory;
  result:=LastError;
  exit;
 end;

 for i:=0 to NumberOfSubTables-1 do begin
  inc(pos,sizeof(word)); // Subtable version number
  SubTableSize:=toWORD(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(word)); // Subtable size
  CoverageFormat:=fontData[pos];
  CoverageFlags:=fontData[pos+1];
  inc(pos,2);
  Next:=Pos+SubTableSize-6;

  if ((CoverageFlags and (2 or 4))<>0) or (CoverageFormat<>0) then begin
   Pos:=Next;
   continue;
  end;

  KerningTables[i].Horizontal:=(CoverageFlags and 1)<>0;
  KerningTables[i].ValueOverride:=(CoverageFlags and 8)<>0;

  NumKerningPairs:=toWORD(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(word));

  inc(pos,sizeof(word)); // Search range
  inc(pos,sizeof(word)); // Entry selector
  inc(pos,sizeof(word)); // Range shift

  KerningTables[i].KerningPairs:=nil;
  setlength(KerningTables[i].KerningPairs,NumKerningPairs);
  if length(KerningTables[i].KerningPairs)<>NumKerningPairs then begin
   LastError:=TT_ERR_OutOfMemory;
   result:=LastError;
   exit;
  end;

  for j:=0 to length(KerningTables[i].KerningPairs)-1 do begin
   KerningTables[i].KerningPairs[j].Left:=toWORD(fontData[pos],fontData[pos+1]);
   inc(pos,sizeof(word));
   KerningTables[i].KerningPairs[j].Right:=toWORD(fontData[pos],fontData[pos+1]);
   inc(pos,sizeof(word));
   KerningTables[i].KerningPairs[j].Value:=toSMALLINT(fontData[pos],fontData[pos+1]);
   inc(pos,sizeof(smallint));
  end;

  KerningTables[i].BinarySearch:=false;
  if length(KerningTables[i].KerningPairs)<>0 then begin
   DoNeedSort:=false;
   for j:=1 to length(KerningTables[i].KerningPairs)-1 do begin
    v1:=(KerningTables[i].KerningPairs[j-1].Left shl 16) or KerningTables[i].KerningPairs[j-1].Right;
    v2:=(KerningTables[i].KerningPairs[j].Left shl 16) or KerningTables[i].KerningPairs[j].Right;
    if v1>=v2 then begin
     DoNeedSort:=true;
     break;
    end;
   end;
   if DoNeedSort then begin
    QuickSort(KerningTables[i].KerningPairs,0,length(KerningTables[i].KerningPairs)-1);
    BeRoSort(KerningTables[i].KerningPairs);
   end;
   KerningTables[i].BinarySearch:=true;
   for j:=1 to length(KerningTables[i].KerningPairs)-1 do begin
    v1:=(KerningTables[i].KerningPairs[j-1].Left shl 16) or KerningTables[i].KerningPairs[j-1].Right;
    v2:=(KerningTables[i].KerningPairs[j].Left shl 16) or KerningTables[i].KerningPairs[j].Right;
    if v1>=v2 then begin
     KerningTables[i].BinarySearch:=false;
     break;
    end;
   end;
  end;
  Pos:=Next;
 end;

 LastError:=TT_ERR_NoError;
 result:=LastError;
end;

function TBeRoVectorFontTrueType.ProcessCharacterMappingTable:integer;
var pos,tag,checksum,offset,size,numsubtables,thisPlatformID,thisSpecificID,thisSubtableOffset,subtableOffset,i,bestsubtableoffset,bestplatformid,bestspecificid:longword;
    subtableLength,bestsubtablepoints,subtablepoints:integer;
    subtablefound:boolean;
begin
 tag:=toLONGWORD(byte('c'),byte('m'),byte('a'),byte('p'));
 result:=GetTableDirEntry(Tag,checksum,offset,size);
 if result<>TT_Err_NoError then exit;
 pos:=offset;
 inc(pos,sizeof(word)); // Table Version number
 numsubtables:=toWORD(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(word));

 bestplatformid:=PlatformID;
 bestspecificid:=SpecificID;
 subtablefound:=false;
 SubtableOffset:=0;
 bestsubtableoffset:=0;
 bestsubtablepoints:=-1;
 i:=0;
 while (i<numsubtables) and not subtablefound do begin
  thisPlatformID:=toWORD(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(word));
  thisSpecificID:=toWORD(fontData[pos],fontData[pos+1]);
  inc(pos,sizeof(word));
  thisSubtableOffset:=toLONGWORD(fontData[pos],fontData[pos+1],fontData[pos+2],fontData[pos+3]);
  inc(pos,sizeof(longword));
  subtablepoints:=0;
  if thisPlatformID=PlatformID then begin
   inc(subtablepoints,10);
  end;
  if thisSpecificID=SpecificID then begin
   inc(subtablepoints,5);
  end;
  if bestsubtablepoints<subtablepoints then begin
   bestsubtablepoints:=subtablepoints;
   bestsubtableOffset:=thisSubtableOffset;
   bestplatformid:=thisPlatformID;
   bestspecificid:=thisSpecificID;
  end;
  if (thisPlatformID=PlatformID) and (thisSpecificID=SpecificID) then begin
   subtablefound:=true;
   SubtableOffset:=thisSubtableOffset;
   bestsubtableOffset:=thisSubtableOffset;
   bestplatformid:=PlatformID;
   bestspecificid:=SpecificID;
   break;
  end;
  inc(i);
 end;
 if (bestsubtablepoints>=0) and not subtablefound then begin
  subtablefound:=true;
  SubtableOffset:=bestSubtableOffset;
  platformid:=bestPlatformID;
  specificid:=bestSpecificID;
 end;

 if not subtablefound then begin
  LastError:=TT_ERR_NoCharacterMapFound;
  result:=LastError;
  exit;
 end;

 pos:=offset+subtableOffset;
 cmapFormat:=toWORD(fontData[pos],fontData[pos+1]);
 inc(pos,sizeof(word));
 subtableLength:=toWORD(fontData[pos],fontData[pos+1]);
//inc(pos,sizeof(word));

 if not (cmapFormat in [CMAP_FORMAT0,CMAP_FORMAT2,CMAP_FORMAT4,CMAP_FORMAT6]) then begin
  LastError:=TT_ERR_UnknownCharacterMapFormat;
  result:=LastError;
  exit;
 end;

 setlength(cmap,subtableLength);
 if length(cmap)<>subtableLength then begin
  LastError:=TT_ERR_OutOfMemory;
  result:=LastError;
  exit;
 end;                     
 move(fontData[offset+subtableOffset],cmap[0],subtableLength);
 
 LastError:=TT_ERR_NoError;
 result:=LastError;
end;

function TBeRoVectorFontTrueType.GetGlyphIndex(CharCode:word):word;
var segcount,FirstCode,EntryCount,u:word;
    endCount,startcount,idDelta,idRangeOffset,glyphIdArray,data,subHeaderKeysData:PByteArray;
    endv,start,delta,range,index,seg,i,numSH,numGlyphId,index1,idx,IDDeltaValue,IDRangeOffsetValue,offset:longword;
    subHeaderKeys:array[0..255] of word;
begin
 LastError:=TT_ERR_NoError;
 if length(cmap)=0 then begin
  LastError:=TT_ERR_CharacterMapNotPresent;
  result:=0;
  exit;
 end;
 case cmapformat of
  CMAP_FORMAT0:begin
   glyphIdArray:=@cmap[6];
   if CharCode in [0..255] then begin
    result:=glyphIdArray^[CharCode];
   end else begin
    result:=0;
   end;
  end;
  CMAP_FORMAT2:begin
   if CharCode<256 then begin
    index:=CharCode;
   end else begin
    index:=CharCode shr 8;
   end;
   subHeaderKeysData:=@cmap[6];
   numSH:=0;
   for i:=0 to 255 do begin
    u:=toWORD(subHeaderKeysData[i*2],subHeaderKeysData[(i*2)+1]) shr 3;
    subHeaderKeys[i]:=u;
    if numSH<u then begin
     numSH:=u;
    end;
   end;
   numGlyphId:=((longword(length(cmap))-(2*(256+3))-(numSH*8)) and $FFFF) div 2;
   index1:=subHeaderKeys[index];
   if index1=0 then begin
    if CharCode<256 then begin
     if CharCode<numGlyphId then begin
      data:=@cmap[6+(256*2)+(numSH*8)];
      result:=toWORD(data^[CharCode*2],data^[(CharCode*2)+1]);
     end else begin
      result:=0;
     end;
    end else begin
     result:=0;
    end;
   end else begin
    if CharCode<256 then begin
     result:=0;
    end else begin
     idx:=CharCode and $ff;
     data:=@cmap[6+(256*2)+(index1*8)];
     FirstCode:=toWORD(data^[0],data^[1]);
     EntryCount:=toWORD(data^[2],data^[3]);
     IDDeltaValue:=toWORD(data^[4],data^[5]);
     IDRangeOffsetValue:=toWORD(data^[6],data^[7])-(((NumSH-index1)*8)+2);
     if (idx>=FirstCode) and (idx<(FirstCode+EntryCount)) then begin
      offset:=(IDRangeOffsetValue div 2)+(idx-FirstCode);
      if offset<numGlyphId then begin
       data:=@cmap[6+(256*2)+(numSH*8)];
       result:=toWORD(data^[offset*2],data^[(offset*2)+1]);
       if result<>0 then begin
        result:=(result+IDDeltaValue) and $ffff;
       end;
      end else begin
       result:=0;
      end;
     end else begin
      result:=0;
     end;
    end;
   end;
  end;
  CMAP_FORMAT4:begin
   segCount:=toWORD(cmap[6],cmap[7]) div 2;
   endCount:=@cmap[14];
   startCount:=@cmap[16+(2*segCount)];
   idDelta:=@cmap[16+(4*segCount)];
   idRangeOffset:=@cmap[16+(6*segCount)];
   seg:=0;
   endv:=toWORD(endCount^[0],endCount^[1]);
   while endv<CharCode do begin
    inc(seg);
    endv:=toWORD(endCount^[seg*2],endCount^[(seg*2)+1]);
   end;
   start:=toWORD(startCount^[seg*2],startCount^[(seg*2)+1]);
   delta:=toWORD(idDelta^[seg*2],idDelta^[(seg*2)+1]);
   range:=toWORD(idRangeOffset[seg*2],idRangeOffset[(seg*2)+1]);
   if start>CharCode then begin
    result:=0;
    exit;
   end;
   if range=0 then begin
    index:=(word(CharCode)+word(delta)) and $ffff;
   end else begin
    index:=range+((CharCode-start)*2)+((16+(6*segCount))+(seg*2));
    index:=toWORD(cmap[index],cmap[index+1]);
    if index<>0 then begin
     index:=(word(index)+word(delta)) and $ffff;
    end;
   end;
   result:=index;
  end;
  CMAP_FORMAT6:begin
   FirstCode:=toWORD(cmap[6],cmap[7]);
   EntryCount:=toWORD(cmap[8],cmap[9]);
   data:=@cmap[10];
   if (CharCode>=FirstCode) and (CharCode<(FirstCode+EntryCount)) then begin
    index:=CharCode-FirstCode;
    result:=toWORD(data^[index*2],data^[(index*2)+1]);
   end else begin
    result:=0;
   end;
  end;
  else begin
   result:=0;
  end;
 end;
end;

function TBeRoVectorFontTrueType.numGlyphs:integer;
begin
 result:=length(Glyphs);
end;

function TBeRoVectorFontTrueType.Glyph(Code:longword):PBeRoVectorCanvasTrueTypeGlyph;
var i:integer;
begin
 if length(Glyphs)<>0 then begin
  i:=GetGlyphIndex(Code);
  if (i>=0) and (i<length(Glyphs)) then begin
   result:=@Glyphs[i];
  end else begin
   result:=nil;
  end;
 end else begin
  result:=nil;
 end;
end;

function TBeRoVectorFontTrueType.Kerning(Left,Right:word;Horizontal:boolean):smallint;
var i,j,beg,mid,endv,idx:integer;
    thiscombined,combined:longword;
begin
 result:=0;
 if length(KerningTables)=0 then exit;
 for i:=0 to length(KerningTables)-1 do begin
  if (length(KerningTables[i].KerningPairs)=0) or (KerningTables[i].Horizontal<>Horizontal) then continue;
  combined:=(Left shl 16) or Right;
  idx:=-1;
  if KerningTables[i].BinarySearch then begin
   beg:=0;
   endv:=length(KerningTables[i].KerningPairs);
   while beg<=endv do begin
    mid:=(beg+endv) div 2;
    thisCombined:=(KerningTables[i].KerningPairs[mid].left shl 16) or KerningTables[i].KerningPairs[mid].right;
    if combined=thisCombined then begin
     idx:=mid;
     break;
    end;
    if combined<thisCombined then begin
     endv:=mid-1;
    end else begin
     beg:=mid+1;
    end;
   end;
  end else begin
   for j:=0 to length(KerningTables[i].KerningPairs)-1 do begin
    thisCombined:=(KerningTables[i].KerningPairs[j].left shl 16) or KerningTables[i].KerningPairs[j].right;
    if combined=thisCombined then begin
     idx:=j;
     break;
    end;
   end;
  end;
  if idx>=0 then begin
   if KerningTables[i].ValueOverride then begin
    result:=KerningTables[i].KerningPairs[idx].value;
   end else begin
    inc(result,KerningTables[i].KerningPairs[idx].value);
   end;
  end;
 end;
end;

function TBeRoVectorFontTrueType.CharacterMap(c:word):word;
begin
 result:=GetGlyphIndex(c);
end;

function TBeRoVectorFontTrueType.CharacterMap(c:widechar):word;
begin
 result:=GetGlyphIndex(word(c));
end;

function TBeRoVectorFontTrueType.NumContours(GlyphNum:word):smallint;
begin
 if GlyphNum<length(Glyphs) then begin
  result:=length(Glyphs[glyphnum].Contours);
 end else begin
  result:=0;
 end;
end;

function TBeRoVectorFontTrueType.NumPoints(GlyphNum,ContourNum:word):smallint;
begin
 if (GlyphNum<length(Glyphs)) and (ContourNum<length(Glyphs[glyphnum].Contours)) then begin
  result:=length(Glyphs[glyphnum].Contours[ContourNum].Points);
 end else begin
  result:=0;
 end;
end;

function TBeRoVectorFontTrueType.PointX(GlyphNum,ContourNum,PointNum:word):integer;
begin
 if (GlyphNum<length(Glyphs)) and (ContourNum<length(Glyphs[glyphnum].Contours)) and (PointNum<length(Glyphs[glyphnum].Contours[ContourNum].Points)) then begin
  result:=Glyphs[glyphnum].Contours[ContourNum].Points[PointNum].x;
 end else begin
  result:=0;
 end;
end;

function TBeRoVectorFontTrueType.PointY(GlyphNum,ContourNum,PointNum:word):integer;
begin
 if (GlyphNum<length(Glyphs)) and (ContourNum<length(Glyphs[glyphnum].Contours)) and (PointNum<length(Glyphs[glyphnum].Contours[ContourNum].Points)) then begin
  result:=Glyphs[glyphnum].Contours[ContourNum].Points[PointNum].y;
 end else begin
  result:=0;
 end;
end;

function TBeRoVectorFontTrueType.OnCurve(GlyphNum,ContourNum,PointNum:word):boolean;
begin
 if (GlyphNum<length(Glyphs)) and (ContourNum<length(Glyphs[glyphnum].Contours)) and (PointNum<length(Glyphs[glyphnum].Contours[ContourNum].Points)) then begin
  result:=Glyphs[glyphnum].Contours[ContourNum].Points[PointNum].OnCurve;
 end else begin
  result:=false;
 end;
end;

function TBeRoVectorFontTrueType.GlyphXMin(GlyphNum:word):smallint;
begin
 if GlyphNum<length(Glyphs) then begin
  result:=Glyphs[glyphnum].XMin;
 end else begin
  result:=0;
 end;
end;

function TBeRoVectorFontTrueType.GlyphYMin(GlyphNum:word):smallint;
begin
 if GlyphNum<length(Glyphs) then begin
  result:=Glyphs[glyphnum].YMin;
 end else begin
  result:=0;
 end;
end;

function TBeRoVectorFontTrueType.GlyphXMax(GlyphNum:word):smallint;
begin
 if GlyphNum<length(Glyphs) then begin
  result:=Glyphs[glyphnum].XMax;
 end else begin
  result:=0;
 end;
end;

function TBeRoVectorFontTrueType.GlyphYMax(GlyphNum:word):smallint;
begin
 if GlyphNum<length(Glyphs) then begin
  result:=Glyphs[glyphnum].YMax;
 end else begin
  result:=0;
 end;
end;

              
constructor TBeRoVectorFont.Create;
begin
 inherited Create;
 Glyphs:=nil;
 KerningTables:=nil;
 Clear;
end;

destructor TBeRoVectorFont.Destroy;
begin
 Clear;
 inherited Destroy;
end;

procedure TBeRoVectorFont.Clear;
var i,j:integer;
begin
 for i:=0 to length(Glyphs)-1 do begin
  for j:=low(Glyphs[i].Styles) to high(Glyphs[i].Styles) do begin
   setlength(Glyphs[i].Styles[j].Polygon.Commands,0);
  end;
 end;
 setlength(Glyphs,0);
 for i:=0 to length(KerningTables)-1 do begin
  setlength(KerningTables[i].KerningPairs,0);
 end;
 setlength(KerningTables,0);
 fillchar(CharacterMap,sizeof(TBeRoVectorFontCharacterMap),#0);
 UnitsPerEm:=1;
 AdvanceWidthMax:=0;
 AdvanceHeightMax:=0;
 Styles:=[];
 Size:=12;
 LetterSpacing:=0;
end;

function TBeRoVectorFont.Kerning(Left,Right:integer;Horizontal:boolean):integer;
var i,j,beg,mid,endv,idx:integer;
    thiscombined,combined:longword;
begin
 result:=0;
 if length(KerningTables)=0 then exit;
 for i:=0 to length(KerningTables)-1 do begin
  if (length(KerningTables[i].KerningPairs)=0) or (KerningTables[i].Horizontal<>Horizontal) then continue;
  combined:=(Left shl 16) or Right;
  idx:=-1;
  if KerningTables[i].BinarySearch then begin
   beg:=0;
   endv:=length(KerningTables[i].KerningPairs);
   while beg<=endv do begin
    mid:=(beg+endv) div 2;
    thisCombined:=(KerningTables[i].KerningPairs[mid].left shl 16) or KerningTables[i].KerningPairs[mid].right;
    if combined=thisCombined then begin
     idx:=mid;
     break;
    end;
    if combined<thisCombined then begin
     endv:=mid-1;
    end else begin
     beg:=mid+1;
    end;
   end;
  end else begin
   for j:=0 to length(KerningTables[i].KerningPairs)-1 do begin
    thisCombined:=(KerningTables[i].KerningPairs[j].left shl 16) or KerningTables[i].KerningPairs[j].right;
    if combined=thisCombined then begin
     idx:=j;
     break;
    end;
   end;
  end;
  if idx>=0 then begin
   if KerningTables[i].ValueOverride then begin
    result:=KerningTables[i].KerningPairs[idx].value;
   end else begin
    inc(result,KerningTables[i].KerningPairs[idx].value);
   end;
  end;
 end;
end;

function TBeRoVectorFont.LoadTrueType(var Data;Size:integer;PlatformID:integer=PID_Microsoft;SpecificID:integer=SID_MS_UNICODE;LanguageID:integer=LID_MS_USEnglish):boolean;
type TPoint=record
      x,y:double;
      oncurve:boolean;
     end;
var TrueType:TBeRoVectorFontTrueType;
    i,j,k,g,h,l,m,thinboldstrength,direction:integer;
    x,y,cx,cy,mx,my,fx,fy,lx,ly,lastx,lasty,xs,ys,sum:double;
    wc:widechar;
    Points:array of TPoint;
    pprev,pfirst,pnext,pcur,pin,pout:TPoint;
    ain,aout,ad,s:single;
    Matrix:TBeRoVectorFontMatrix;
    oncurve:boolean;
begin
 Points:=nil;
 result:=false;
 try
  Clear;
  TrueType:=TBeRoVectorFontTrueType.Create(@Data,size,PlatformID,SpecificID,LanguageID);
  if TrueType.LastError=TT_ERR_NoError then begin
   Name:=TrueType.strfullName;
   AdvanceWidthMax:=TrueType.AdvanceWidthMax;
   AdvanceHeightMax:=TrueType.AdvanceHeightMax;
   UnitsPerEm:=TrueType.unitsPerEm;
   if UnitsPerEm=0 then begin
    UnitsPerEm:=1;
   end;
   XMin:=TrueType.XMin;
   YMin:=TrueType.YMin;
   XMax:=TrueType.XMax;
   YMax:=TrueType.YMax;
   thinboldstrength:=UnitsPerEm div 16;
   setlength(Glyphs,length(TrueType.Glyphs));
   for i:=0 to length(TrueType.Glyphs)-1 do begin
    fillchar(Glyphs[i],sizeof(TBeRoVectorFontGlyph),#0);
    Glyphs[i].AdvanceWidth:=TrueType.Glyphs[i].AdvanceWidth;
    Glyphs[i].AdvanceHeight:=TrueType.Glyphs[i].AdvanceHeight;
    Glyphs[i].LeftSideBearing:=TrueType.Glyphs[i].LeftSideBearing;
    Glyphs[i].RightSideBearing:=TrueType.Glyphs[i].RightSideBearing;
    Glyphs[i].TopSideBearing:=TrueType.Glyphs[i].TopSideBearing;
    Glyphs[i].BottomSideBearing:=TrueType.Glyphs[i].BottomSideBearing;
    Glyphs[i].XMin:=TrueType.Glyphs[i].XMin;
    Glyphs[i].YMin:=TrueType.Glyphs[i].YMin;
    Glyphs[i].XMax:=TrueType.Glyphs[i].XMax;
    Glyphs[i].YMax:=TrueType.Glyphs[i].YMax;
    for g:=0 to 5 do begin
     Glyphs[i].Styles[g].AdvanceWidth:=Glyphs[i].AdvanceWidth;
     Glyphs[i].Styles[g].AdvanceHeight:=Glyphs[i].AdvanceHeight;
     Glyphs[i].Styles[g].LeftSideBearing:=Glyphs[i].LeftSideBearing;
     Glyphs[i].Styles[g].RightSideBearing:=Glyphs[i].RightSideBearing;
     Glyphs[i].Styles[g].TopSideBearing:=Glyphs[i].TopSideBearing;
     Glyphs[i].Styles[g].BottomSideBearing:=Glyphs[i].BottomSideBearing;
     Glyphs[i].Styles[g].XMin:=Glyphs[i].XMin;
     Glyphs[i].Styles[g].YMin:=Glyphs[i].YMin;
     Glyphs[i].Styles[g].XMax:=Glyphs[i].XMax;
     Glyphs[i].Styles[g].YMax:=Glyphs[i].YMax;
     if g in [2,3] then begin
      // Thin
      dec(Glyphs[i].Styles[g].AdvanceWidth,thinboldstrength);
      dec(Glyphs[i].Styles[g].LeftSideBearing,thinboldstrength);
      dec(Glyphs[i].Styles[g].RightSideBearing,thinboldstrength);
      dec(Glyphs[i].Styles[g].XMax,thinboldstrength);
     end;
     if g in [4,5] then begin
      // Bold
      inc(Glyphs[i].Styles[g].AdvanceWidth,thinboldstrength);
      inc(Glyphs[i].Styles[g].LeftSideBearing,thinboldstrength);
      inc(Glyphs[i].Styles[g].RightSideBearing,thinboldstrength);
      inc(Glyphs[i].Styles[g].XMax,thinboldstrength);
     end;
    end;
    sum:=0;
    for j:=0 to length(TrueType.Glyphs[i].Contours)-1 do begin
     if length(TrueType.Glyphs[i].Contours[j].Points)=0 then begin
      continue;
     end;
     x:=TrueType.Glyphs[i].Contours[j].Points[0].x;
     y:=TrueType.Glyphs[i].Contours[j].Points[0].y;
     xs:=x;
     ys:=y;
     for k:=1 to length(TrueType.Glyphs[i].Contours[j].Points)-1 do begin
      sum:=sum+((x*TrueType.Glyphs[i].Contours[j].Points[k].y)-(y*TrueType.Glyphs[i].Contours[j].Points[k].x));
      x:=TrueType.Glyphs[i].Contours[j].Points[k].x;
      y:=TrueType.Glyphs[i].Contours[j].Points[k].y;
     end;
     sum:=sum+((x*ys)-(y*xs));
    end;
    if sum<0 then begin
     direction:=1;
    end else begin
     direction:=-1;
    end;
    for j:=0 to length(TrueType.Glyphs[i].Contours)-1 do begin
     if length(TrueType.Glyphs[i].Contours[j].Points)<2 then begin
      continue;
     end;
     setlength(Points,length(TrueType.Glyphs[i].Contours[j].Points));
     for g:=0 to 5 do begin
      for k:=0 to length(TrueType.Glyphs[i].Contours[j].Points)-1 do begin
       Points[k].oncurve:=TrueType.Glyphs[i].Contours[j].Points[k].OnCurve;
       Points[k].x:=TrueType.Glyphs[i].Contours[j].Points[k].x;
       Points[k].y:=TrueType.Glyphs[i].Contours[j].Points[k].y;
      end;
      if g in [2,3,4,5] then begin
       // Thin/Bold
       pfirst:=Points[0];
       pprev:=Points[length(Points)-1];
       pcur:=pfirst;
       for k:=0 to length(Points)-1 do begin
        if (k+1)<length(Points) then begin
         pnext:=Points[k+1];
        end else begin
         pnext:=pfirst;
        end;
        pin.x:=pcur.x-pprev.x;
        pin.y:=pcur.y-pprev.y;
        pout.x:=pnext.x-pcur.x;
        pout.y:=pnext.y-pcur.y;
        ain:=arctan2(pin.y,pin.x);
        aout:=arctan2(pout.y,pout.x);
        ad:=aout-ain;
        s:=cos(ad*0.5);
        if abs(s)<=0.25 then begin
         pin.x:=0;
         pin.y:=0;
        end else begin
         pin.x:=SoftTRUNC((thinboldstrength div 2)/s);
         pin.y:=0;
         if g in [2,3] then begin
          // Thin
          Matrix:=MatrixRotate(((ain+(ad*0.5)-((pi*0.5)*direction))*rad2deg));
         end else begin
          // Bold
          Matrix:=MatrixRotate(((ain+(ad*0.5)+((pi*0.5)*direction))*rad2deg));
         end;
         ApplyMatrixToXY(Matrix,pin.x,pin.y);
        end;
        Points[k].x:=pcur.x+thinboldstrength+pin.x;
        Points[k].y:=pcur.y+thinboldstrength+pin.y;
        pprev:=pcur;
        pcur:=pnext;
       end;
      end;
      if g in [1,3,5] then begin
       // Italic
       for k:=0 to length(Points)-1 do begin
        // Rotate only x coord by about 12 degrees
        Matrix[0]:=1;
        Matrix[1]:=0;
        Matrix[2]:=0.375;
        Matrix[3]:=1;
        Matrix[4]:=0;
        Matrix[5]:=0;
        ApplyMatrixToXY(Matrix,Points[k].x,Points[k].y);
       end;
      end;
      for k:=0 to length(Points)-1 do begin
       Points[k].y:=YMax-Points[k].y;
      end;
      fx:=Points[0].x;
      fy:=Points[0].y;
      lx:=Points[length(Points)-1].x;
      ly:=Points[length(Points)-1].y;
      lastx:=fx;
      lasty:=fy;
      cx:=fx;
      cy:=fx;
      oncurve:=Points[0].oncurve;
      if not oncurve then begin
       if Points[length(Points)-1].oncurve then begin
        lastx:=lx;
        lasty:=ly;
       end else begin
        lastx:=(lastx+lx)*0.5;
        lasty:=(lasty+ly)*0.5;
        lx:=lastx;
        ly:=lasty;
       end;
      end;
      h:=length(Glyphs[i].Styles[g].Polygon.Commands);
      setlength(Glyphs[i].Styles[g].Polygon.Commands,h+1);
      Glyphs[i].Styles[g].Polygon.Commands[h].CommandType:=bvfcspctMOVETO;
      Glyphs[i].Styles[g].Polygon.Commands[h].Points[0].x:=fx;
      Glyphs[i].Styles[g].Polygon.Commands[h].Points[0].y:=fy;
      for k:=1 to length(Points)-1 do begin
       x:=Points[k].x;
       y:=Points[k].y;
       if oncurve then begin
        oncurve:=Points[k].oncurve;
        if oncurve then begin
         h:=length(Glyphs[i].Styles[g].Polygon.Commands);
         setlength(Glyphs[i].Styles[g].Polygon.Commands,h+1);
         Glyphs[i].Styles[g].Polygon.Commands[h].CommandType:=bvfcspctLINETO;
         Glyphs[i].Styles[g].Polygon.Commands[h].Points[0].x:=x;
         Glyphs[i].Styles[g].Polygon.Commands[h].Points[0].y:=y;
        end else begin
         cx:=x;
         cy:=y;
        end;
       end else begin
        oncurve:=Points[k].oncurve;
        if oncurve then begin
         h:=length(Glyphs[i].Styles[g].Polygon.Commands);
         setlength(Glyphs[i].Styles[g].Polygon.Commands,h+1);
         Glyphs[i].Styles[g].Polygon.Commands[h].CommandType:=bvfcspctCURVETO;
         Glyphs[i].Styles[g].Polygon.Commands[h].Points[0].x:=cx;
         Glyphs[i].Styles[g].Polygon.Commands[h].Points[0].y:=cy;
         Glyphs[i].Styles[g].Polygon.Commands[h].Points[1].x:=x;
         Glyphs[i].Styles[g].Polygon.Commands[h].Points[1].y:=y;
        end else begin
         mx:=(cx+x)*0.5;
         my:=(cy+y)*0.5;
         h:=length(Glyphs[i].Styles[g].Polygon.Commands);
         setlength(Glyphs[i].Styles[g].Polygon.Commands,h+1);
         Glyphs[i].Styles[g].Polygon.Commands[h].CommandType:=bvfcspctCURVETO;
         Glyphs[i].Styles[g].Polygon.Commands[h].Points[0].x:=cx;
         Glyphs[i].Styles[g].Polygon.Commands[h].Points[0].y:=cy;
         Glyphs[i].Styles[g].Polygon.Commands[h].Points[1].x:=mx;
         Glyphs[i].Styles[g].Polygon.Commands[h].Points[1].y:=my;
         cx:=x;
         cy:=y;
        end;
       end;
      end;
      if Points[0].oncurve then begin
       if oncurve then begin
        h:=length(Glyphs[i].Styles[g].Polygon.Commands);
        setlength(Glyphs[i].Styles[g].Polygon.Commands,h+1);
        Glyphs[i].Styles[g].Polygon.Commands[h].CommandType:=bvfcspctLINETO;
        Glyphs[i].Styles[g].Polygon.Commands[h].Points[0].x:=fx;
        Glyphs[i].Styles[g].Polygon.Commands[h].Points[0].y:=fy;
       end else begin
        h:=length(Glyphs[i].Styles[g].Polygon.Commands);
        setlength(Glyphs[i].Styles[g].Polygon.Commands,h+1);
        Glyphs[i].Styles[g].Polygon.Commands[h].CommandType:=bvfcspctCURVETO;
        Glyphs[i].Styles[g].Polygon.Commands[h].Points[0].x:=cx;
        Glyphs[i].Styles[g].Polygon.Commands[h].Points[0].y:=cy;
        Glyphs[i].Styles[g].Polygon.Commands[h].Points[1].x:=fx;
        Glyphs[i].Styles[g].Polygon.Commands[h].Points[1].y:=fy;
       end;
      end else begin
       if not oncurve then begin
        h:=length(Glyphs[i].Styles[g].Polygon.Commands);
        setlength(Glyphs[i].Styles[g].Polygon.Commands,h+1);
        Glyphs[i].Styles[g].Polygon.Commands[h].CommandType:=bvfcspctCURVETO;
        Glyphs[i].Styles[g].Polygon.Commands[h].Points[0].x:=cx;
        Glyphs[i].Styles[g].Polygon.Commands[h].Points[0].y:=cy;
        Glyphs[i].Styles[g].Polygon.Commands[h].Points[1].x:=lx;
        Glyphs[i].Styles[g].Polygon.Commands[h].Points[1].y:=ly;
       end;
      end;
     end;
    end;
   end;
   setlength(KerningTables,length(TrueType.KerningTables));
   for i:=0 to length(TrueType.KerningTables)-1 do begin
    KerningTables[i].Horizontal:=TrueType.KerningTables[i].Horizontal;
    KerningTables[i].ValueOverride:=TrueType.KerningTables[i].ValueOverride;
    KerningTables[i].BinarySearch:=TrueType.KerningTables[i].BinarySearch;
    setlength(KerningTables[i].KerningPairs,length(TrueType.KerningTables[i].KerningPairs));
    for j:=0 to length(TrueType.KerningTables[i].KerningPairs)-1 do begin
     KerningTables[i].KerningPairs[j].Left:=TrueType.KerningTables[i].KerningPairs[j].Left;
     KerningTables[i].KerningPairs[j].Right:=TrueType.KerningTables[i].KerningPairs[j].Right;
     KerningTables[i].KerningPairs[j].Value:=TrueType.KerningTables[i].KerningPairs[j].Value;
    end;
   end;
   for wc:=#$0000 to #$ffff do begin
    CharacterMap[wc]:=TrueType.CharacterMap(wc);
    if wc<#$fff then begin
     if CharacterMap[wc]=0 then begin
      j:=TrueType.CharacterMap(widechar(word(word(wc) or $f000)));
      if j<>0 then begin
       CharacterMap[wc]:=j;
      end;
     end;
    end;
   end;
   result:=true;
  end else begin
   result:=false;
  end;
  TrueType.Destroy;
 except
  result:=false;
 end;
 setlength(Points,0);
end;

function TBeRoVectorFont.LoadTrueType(FileName:string;PlatformID:integer=PID_Microsoft;SpecificID:integer=SID_MS_UNICODE;LanguageID:integer=LID_MS_USEnglish):boolean;
var f:file;
    fp:pointer;
    fs,fr:integer;
begin
 result:=false;
 try
  assignfile(f,FileName);
  {$i-}reset(f,1);{$i+}
  if ioresult=0 then begin
   fs:=filesize(f);
   if fs<>0 then begin
    getmem(fp,fs);
    {$i-}blockread(f,fp^,fs,fr);{$i+}
    if (ioresult=0) and (fs=fr) then begin
     result:=LoadTrueType(fp^,fs,PlatformID,SpecificID,LanguageID);
     if result then begin
      if length(trim(Name))=0 then begin
       Name:=ChangeFileExt(ExtractFileName(FileName),'');
       if length(trim(Name))=0 then begin
        Name:=ExtractFileName(FileName);
       end;
      end;
     end;
    end;
    freemem(fp);
   end;
   closefile(f);
  end;
 except
  result:=false;
 end;
end;

function TBeRoVectorFont.TextWidth(Text:widestring):double;
var s,i,j,r:integer;
    first:boolean;
begin
 r:=0;
 if bvfsBOLD in Styles then begin
  if bvfsITALIC in Styles then begin
   s:=5;
  end else begin
   s:=4;
  end;
 end else if bvfsTHIN in Styles then begin
  if bvfsITALIC in Styles then begin
   s:=3;
  end else begin
   s:=2;
  end;
 end else begin
  if bvfsITALIC in Styles then begin
   s:=1;
  end else begin
   s:=0;
  end;
 end;
 first:=true;
 for i:=1 to length(Text) do begin
  j:=CharacterMap[Text[i]];
  if (j<0) or (j>=length(Glyphs)) then begin
   continue;
  end;
  if first then begin
   first:=false;
   r:=Glyphs[j].Styles[s].LeftSideBearing;
  end;
  inc(r,Glyphs[j].Styles[s].AdvanceWidth);
  if (i+1)<=length(Text) then begin
   inc(r,Kerning(j,CharacterMap[Text[i+1]],true));
  end;
  if r<abs(Glyphs[j].Styles[s].XMax-Glyphs[j].Styles[s].XMin) then begin
   r:=abs(Glyphs[j].Styles[s].XMax-Glyphs[j].Styles[s].XMin);
  end;
 end;
 result:=((r+(length(Text)*LetterSpacing))*Size)/UnitsPerEm;
end;

function TBeRoVectorFont.TextHeight(Text:widestring):double;
var s,i,j,r:integer;
    first:boolean;
begin
 r:=0;
 if bvfsBOLD in Styles then begin
  if bvfsITALIC in Styles then begin
   s:=5;
  end else begin
   s:=4;
  end;
 end else if bvfsTHIN in Styles then begin
  if bvfsITALIC in Styles then begin
   s:=3;
  end else begin
   s:=2;
  end;
 end else begin
  if bvfsITALIC in Styles then begin
   s:=1;
  end else begin
   s:=0;
  end;
 end;
 first:=true;
 for i:=1 to length(Text) do begin
  j:=CharacterMap[Text[i]];
  if (j<0) or (j>=length(Glyphs)) then begin
   continue;
  end;
  if first then begin
   first:=false;
   r:=Glyphs[j].Styles[s].TopSideBearing;
  end;
  inc(r,Glyphs[j].Styles[s].AdvanceHeight);
  if (i+1)<=length(Text) then begin
   inc(r,Kerning(j,CharacterMap[Text[i+1]],false));
  end;
  if r<abs(Glyphs[j].Styles[s].YMax-Glyphs[j].Styles[s].YMin) then begin
   r:=abs(Glyphs[j].Styles[s].YMax-Glyphs[j].Styles[s].YMin);
  end;
 end;
 result:=(r*Size)/UnitsPerEm;
end;

procedure TBeRoVectorFont.GetCommands(var Commands:TBeRoVectorFontCommands;x,y:double;Text:widestring);
var s,i,j,k,cx,cy,ni,nc:integer;
    ss:double;
    first:boolean;
begin
 setlength(Commands,0);
 if bvfsBOLD in Styles then begin
  if bvfsITALIC in Styles then begin
   s:=5;
  end else begin
   s:=4;
  end;
 end else if bvfsTHIN in Styles then begin
  if bvfsITALIC in Styles then begin
   s:=3;
  end else begin
   s:=2;
  end;
 end else begin
  if bvfsITALIC in Styles then begin
   s:=1;
  end else begin
   s:=0;
  end;
 end;
 cx:=0;
 cy:=0;
 first:=true;
 ss:=Size/UnitsPerEm;
 nc:=0;
 for i:=1 to length(Text) do begin
  j:=CharacterMap[Text[i]];
  if (j<0) or (j>=length(Glyphs)) then begin
   continue;
  end;
  if length(Glyphs[j].Styles[s].Polygon.Commands)>0 then begin
   inc(nc,length(Glyphs[j].Styles[s].Polygon.Commands)+1);
  end;
 end;
 setlength(Commands,nc);
 ni:=0;
 for i:=1 to length(Text) do begin
  j:=CharacterMap[Text[i]];
  if (j<0) or (j>=length(Glyphs)) then begin
   continue;
  end;
  if first then begin
   first:=false;
   cx:=Glyphs[j].Styles[s].LeftSideBearing;
   cy:=Glyphs[j].Styles[s].TopSideBearing;
  end;
  if length(Glyphs[j].Styles[s].Polygon.Commands)>0 then begin
   for k:=0 to length(Glyphs[j].Styles[s].Polygon.Commands)-1 do begin
    case Glyphs[j].Styles[s].Polygon.Commands[k].CommandType of
     bvfcspctMOVETO:begin
      Commands[ni].Command:=bvfctMOVETO;
      Commands[ni].x:=x+((cx+Glyphs[j].Styles[s].Polygon.Commands[k].Points[0].x+(i*LetterSpacing))*ss);
      Commands[ni].y:=y+((cy+Glyphs[j].Styles[s].Polygon.Commands[k].Points[0].y)*ss);
     end;
     bvfcspctLINETO:begin
      Commands[ni].Command:=bvfctLINETO;
      Commands[ni].x:=x+((cx+Glyphs[j].Styles[s].Polygon.Commands[k].Points[0].x+(i*LetterSpacing))*ss);
      Commands[ni].y:=y+((cy+Glyphs[j].Styles[s].Polygon.Commands[k].Points[0].y)*ss);
     end;
     bvfcspctCURVETO:begin
      Commands[ni].Command:=bvfctQUADRATICCURVETO;
      Commands[ni].qcx:=x+((cx+Glyphs[j].Styles[s].Polygon.Commands[k].Points[0].x+(i*LetterSpacing))*ss);
      Commands[ni].qcy:=y+((cy+Glyphs[j].Styles[s].Polygon.Commands[k].Points[0].y)*ss);
      Commands[ni].qax:=x+((cx+Glyphs[j].Styles[s].Polygon.Commands[k].Points[1].x+(i*LetterSpacing))*ss);
      Commands[ni].qay:=y+((cy+Glyphs[j].Styles[s].Polygon.Commands[k].Points[1].y)*ss);
     end;
     else begin
      Commands[ni].Command:=bvfctNONE;
     end;
    end;
    inc(ni);
   end;
   Commands[ni].Command:=bvfctCLOSE;
   inc(ni);
  end;
  inc(cx,Glyphs[j].Styles[s].AdvanceWidth);
  inc(cy,Glyphs[j].Styles[s].AdvanceHeight);
  if (i+1)<=length(Text) then begin
   inc(cx,Kerning(j,CharacterMap[Text[i+1]],true));
   inc(cy,Kerning(j,CharacterMap[Text[i+1]],false));
  end;
 end;
end;

end.
